<?
// Allow access from any host
header('Access-Control-Allow-Origin: *');
set_time_limit(300);
include_once 'engine/database.php';
$database = new Database();
include_once 'engine/project.php';
$project = new Project($database);
include_once 'engine/api.php';
$api = new Api();
$action				= $_GET['action'];
$strOutputFormat	= $_GET['output'];
if ($strOutputFormat == 'json') {
	header('Content-type: application/json');
} else if ($strOutputFormat == 'csv') {
	header('Content-type: text/plain');
} else {
	header('Content-type: text/xml');
}
switch ($action) {
case 'login':
	$strEmail 		= $_GET['email'];
	$strPassword 	= $_GET['password'];
	$strResponse	= $api->login($strEmail, $strPassword, false, $strOutputFormat);
	echo $strResponse;
	break;

case 'listuserprojects':
	$strToken 		= $_GET['token'];
	$strResponse 	= $api->listuserprojects($strToken, $strOutputFormat);
	echo $strResponse;
	break;

case 'listprojectusers': 
	$idProject 		= $_GET['pid'];
	$strToken 		= $_GET['token'];
	$strResponse 	= $api->listprojectusers($idProject, $strToken, $strOutputFormat);
	echo $strResponse;
	break;

case 'listprojectforms': 
	$idProject 		= $_GET['pid'];
	$strToken 		= $_GET['token'];
	$strResponse	= $api->listprojectforms($idProject, $strToken, $strOutputFormat);
	echo $strResponse;
	break;
	
case 'listprojectrecords': 
	$idProject 		= $_GET['pid'];
	$idUser 		= $_GET['uid'];
	$dtDateFrom		= $_GET['fromdate'];
	$intLimit		= $_GET['limit'];
	$strToken 		= $_GET['token'];
	$strResponse	= $api->listprojectrecords($idProject, $idUser, $dtDateFrom, $intLimit, $strToken, $strOutputFormat);
	echo $strResponse;
	break;

case 'listforminfo':
	$idForm			= $_GET['idform'];
	$strToken		= $_GET['token'];
	$strResponse	= $api->listforminfo($idForm, $strToken, $strOutputFormat);
	echo $strResponse;
	break;
	
case 'listevents': 
	$strIDs 		= $_GET['ids'];
	$dtDateFrom		= $_GET['fromdate'];
	$intLimit		= $_GET['limit'];
	$strResponse	= $api->listevents($strIDs, $dtDateFrom, $intLimit, $strOutputFormat);
	echo $strResponse;
	break;
	
case 'deleterecord':
	$idFormRecord 	= $_GET['idrecord'];
	$idUser 		= $_GET['iduser'];
	$strToken 		= $_GET['token'];
	$strResponse	= $api->deleterecord($idFormRecord, $idUser, $strToken, $strOutputFormat);
	echo $strResponse;
	break;
	
case 'deleteuser':
	$idUser			= $_GET['uid'];
	$strToken 		= $_GET['token'];
	$strResponse	= $api->deleteuser($idUser, $strToken, $strOutputFormat);
	echo $strResponse;
	break;
	
// Vicon Mobile sends data inside header
case 'insertrecord':
	$strJSON = file_get_contents("php://input");
	$strResponse = $api->insertrecordmobile($strJSON, $strOutputFormat);
	echo $strResponse;
	break;	

case 'insertrecords':
	$idForm 		= $_GET['idform'];
	$data			= file_get_contents("php://input");
	$strToken 		= $_GET['token'];
	$strResponse 	= $api->insertrecords($idForm, $data, $strToken, $strOutputFormat);
	echo $strResponse;
	break;
	
case 'insertuserposition':
	$idUser 		= $_GET['uid'];
	$dblLatitude	= $_GET['lat'];
	$dblLongitude	= $_GET['lng'];
	$strToken 		= $_GET['token'];
	$strResponse 	= $api->insertuserposition($dblLatitude, $dblLongitude, $strToken, $idUser, $strOutputFormat);
	echo $strResponse;
	break;	

case 'searchradius':
	$strSearchType 	= 1; // Search Radius
	$idProject	 	= $_GET['pid'];
	$dblLatitude 	= $_GET['lat'];
	$dblLongitude 	= $_GET['lng'];
	$intRadius 		= $_GET['radius'];
	$strToken 		= $_GET['token'];
	$strKeyword		= $_GET['keyword'];
	$intStart		= $_GET['start'];
	$idForm			= $_GET['idform'];
	$dtDateFrom		= $_GET['fromdate'];
	$dtDateTo		= $_GET['todate'];
	$intLimit		= $_GET['limit'];
	$strResponse	= $api->search($strSearchType, $idProject, $dblLatitude, $dblLongitude, $dblLatitude, $dblLongitude, $intRadius, $strKeyword, $strToken, $intStart, $idForm, $dtDateFrom, $dtDateTo, $intLimit, $strOutputFormat);
	echo $strResponse;
	break;

case 'searchrectangle':
	$strSearchType 	= 2; // Search by Rectangle
	$idProject	 	= $_GET['pid'];
	$dblLatitudeSW	= $_GET['latSW'];
	$dblLongitudeSW = $_GET['lngSW'];
	$dblLatitudeNE	= $_GET['latNE'];
	$dblLongitudeNE	= $_GET['lngNE'];
	$strToken 		= $_GET['token'];
	$strKeyword		= $_GET['keyword'];
	$intStart		= $_GET['start'];
	$idForm			= $_GET['idform'];
	$dtDateFrom		= $_GET['fromdate'];
	$dtDateTo		= $_GET['todate'];
	$intLimit		= $_GET['limit'];
	$strResponse	= $api->search($strSearchType, $idProject, $dblLatitudeSW, $dblLongitudeSW, $dblLatitudeNE, $dblLongitudeNE, 0, $strKeyword, $strToken, $intStart, $idForm, $dtDateFrom, $dtDateTo, $intLimit, $strOutputFormat);
	echo $strResponse;
	break;

case 'recordinfo':
	$idFormRecord	= $_GET['idrecord'];
	$strToken 		= $_GET['token'];
	$strResponse	= $api->recordinfo($idFormRecord, $strToken, $strOutputFormat);
	echo $strResponse;
	break;

case 'projectlastupdate':
	$idProject		= $_GET['pid'];
	$idUser 		= $_GET['uid'];
	$strResponse	= $api->projectlastupdate($idProject, $idUser, $strOutputFormat);
	echo $strResponse;
	break;

case 'generatereport':
	$idProject	 	= $_GET['pid'];
	$strExtension	= strtolower($_GET['ext']);
	$strToken 		= $_GET['token'];
	$strResponse	= $api->generatereport($idProject, $strExtension, $strToken, $strOutputFormat);
	echo $strResponse;
	break;
	
case 'live-kml':
	$idProject	 	= $_GET['pid'];
	$strResponse	= $api->liveKML($idProject);
	echo utf8_encode($strResponse);
	break;
	
case 'wfs':
//$project->strings->log($_GET['REQUEST'] . ':' . $_SERVER['REQUEST_URI'], 'tmp/out.txt', true);
	$idProject 			= (isset($_GET['alias']) ? $project->selectidProjectByAlias($_GET['alias']) : $_GET['pid']);
	$strEmail 			= $_GET['email'] ? $_GET['email'] : $_HEADER['user'];
	$strPassword 		= $_GET['password'];
	$blnSummary			= $_GET['summary'];
	$strRequest			= $_GET['REQUEST'] ? $_GET['REQUEST'] : $_GET['request'];
	$strTypeName		= $_GET['TYPENAME'] ? $_GET['TYPENAME'] : $_GET['typename'];
	$strResponse		= $api->wfs($idProject, $strEmail, $strPassword, $blnSummary, $strRequest, $strTypeName);
	echo $strResponse;
	break;
	
case 'geodesign-wfs':
	$strToken		= $_GET['token'];
	$strResponse	= $api->geodesignWFS($strToken, $_GET['REQUEST'], $_GET['TYPENAME']);
	echo $strResponse;
	break;
	
case 'geodesign-csv-projects':
	$strToken		= $_GET['token'];
	$strResponse	= $api->geodesignCSVProjects($strToken);
	echo $strResponse;
	break;

case 'geodesign-csv-diagrams':
	$strToken		= $_GET['token'];
	$idProject		= $_GET['idproject'];
	$strResponse	= $api->geodesignCSVDiagrams($strToken, $idProject);
	echo $strResponse;
	break;
	
case 'geodesign-live-kml':
	$strToken		= $_GET['token'];
	$idProject		= $_GET['idproject'];
	$strResponse	= $api->geodesignLiveKML($strToken, $idProject);
	echo utf8_encode($strResponse);
	break;
	
case 'mobile-chart-load':
	$arrResult = $api->formrecord->chartLoad($_GET['idFormField'], $_GET['strChartType'], $_GET['dtDateFrom'], $_GET['dtDateTo']);
	echo json_encode($api->formrecord->strings->encodeArray($arrResult));
	break;
}
?>