<?php
  // Documentation Page: http://www.geodesignsupport.com/kb/get-methods/
  // Token Request: https://www.geodesignhub.com/accounts/login/?next=/api/token/
  if (! $_GET['token']) {
	  echo 'Token parameter required. Go to <a href="https://www.geodesignhub.com/accounts/login/?next=/api/token/">https://www.geodesignhub.com/accounts/login/?next=/api/token/</a> to get your token';
	  exit;
  }
  $strAPIURL = "https://www.geodesignhub.com/api/v1/projects/";
  include_once '../engine/strings.php';
  $strings = new Strings();
  header('Content-type: text/xml');
  set_time_limit(120);
  $arrResult = array();
  //$_GET['token'] = $_GET['token'] ? $_GET['token'] : 'bd582a22621c26b5800d39d1f33856cbf538384f';
  $arrProjects = get($strAPIURL, $strings, $_GET['token']);
  foreach ($arrProjects as $arrProject) {
	$arrDiagrams = get($strAPIURL . $arrProject['id'] . '/diagrams/all/', $strings, $_GET['token']);
	foreach ($arrDiagrams as $arrDiagram) {
	  // Stop if reaches limit
	  if (($_GET['limit']) && (count($arrResult['record']) >= $_GET['limit'])) { 
		$strXML = $strings->strArrayToXML2($arrResult);
		echo $strXML;
		exit;
	  }
	  // Filter by Strings
	  if ( 
		  ($_GET['q']) &&
		  (stripos($arrDiagram['geojson']['features'][0]['properties']['author'], $_GET['q']) === FALSE) &&
		  (stripos($arrDiagram['description'], $_GET['q']) === FALSE)
	  ) { continue; } 
	  $arrRecord = array();
	  $arrRecord['description'] = $arrDiagram['description'];
	  $arrRecord['sysid'] = $arrDiagram['sysid'];
	  if ($arrDiagram['geojson']['features']) {
		$arrRecord['intShapeType'] = $arrDiagram['geojson']['features'][0]['geometry']['type'] == 'Polygon' ? 3 : 2;
		$arrRecord['author'] = $arrDiagram['geojson']['features'][0]['properties']['author'];
		$arrRecord['areatype'] = $arrDiagram['geojson']['features'][0]['properties']['areatype'];
		$arrRecord['color'] = substr($arrDiagram['geojson']['features'][0]['properties']['color'], 1, 10);
		$arrCoordinates = $arrDiagram['geojson']['features'][0]['geometry']['coordinates'][0];
		$arrVtcs = array();
		$arrVertexs = array();
		if (count($arrCoordinates)) {
			foreach ($arrCoordinates as $arrCoordinate) {
				$arrVertexs[] = $arrCoordinate[0] . ',' .  $arrCoordinate[1];
			}
		}
	  }
	  $arrRecord['id'] = $arrDiagram['geojson']['features'][0]['properties']['diagramid'];
	  $arrRecord['date'] = date('Y-m-d H:i:s');
	  $arrRecord['coordinates'] = implode(' ', $arrVertexs);
	  $arrResult['record'][] = $arrRecord;
	}
  }
  echo $strings->strArrayToXML2($arrResult);
  
  function get($strURL, $strings, $accountAccessToken) {
	  $strJSON = $strings->processUrl($strURL, array('Authorization: Token ' . $accountAccessToken));
	  $arrResult = $strings->objectify('array', $strJSON);
	  return $arrResult;
  }
?>