<?php
class Censo {
	public $arrUFs;
	public $arrTabelas;
	public $database;
	var $lastErr		= null;
	var $server 		= '';
	var $mydb		= '';
	var $username	= '';
	var $password	= '';
	public $strFormName	= 'Censo IBGE 2010';
	public $strDataDir	= 'censo';
	public $strCSVDir	= 'censo/CSV';
	public $strSHPDir	= 'censo/SHP';
	public $strOutputFileName	= 'censo';
	public $strConnectionFilePath = 'censo/connection.inc';
	public $strGoogleFusionTablesFieldPolys			= 'geometry';
	public $strGoogleFusionTablesPolyFillColor		= '#FFFFFF';
	public $dblGoogleFusionTablesPolyFillOpacity	= 0.01;
	public $strGoogleFusionTablesPolyStrokeColor	= '#FF0000';
	public $dblGoogleFusionTablesPolyStrokeOpacity	= 1;
	public $intGoogleFusionTablesPolyStrokeWeight	= 1;
	public $chrNoValue = '';
	public $headerInfo = array();
	public $arrDBFFields = array();
	public $arrInserts = array();
	private $shpFilePath;
	private $shpFile;
	private $shpData = array();
	private $dbf;

	public function __construct($strPrefix = '') {
		include_once $strPrefix . $this->strConnectionFilePath;
		$this->server 		= $server;
		$this->username 	= $username;
		$this->password 	= $password;
		$this->mydb			= $database;
		if (strpos($_SERVER["HTTP_HOST"],'localhost') !== FALSE) { 
			$this->server 		= 'localhost';
			$this->username		= 'root';
			$this->password		= '';
			$this->mydb			= 'ibge';
		}
		$this->database = mysql_connect($this->server, $this->username, $this->password);
		mysql_select_db($this->mydb, $this->database);
		$this->setLastErr();
		$this->arrUFs = $this->selectUFs();
		$this->arrTabelas = $this->selectTabelas();
		
		include_once 'strings.php';
		$strings = new Strings();
		$this->strings = $strings;
		
		require_once 'rs2.php';
		$rs2 = new rs2();
		$this->rs2 = $rs2;
		
		include 'shapefile/reader/dbase.php';
		include 'shapefile/writer/Shapefile.php';
		include 'dbf/Column.class.php';
		include 'dbf/Record.class.php';
		include 'dbf/Table.class.php';
		include 'dbf/WritableTable.class.php';
	}
	
	public function selectTabelas($idTabela = 0) {
		$query =
		"SELECT
			t.idTabela,
			t.strName
		FROM
			tabela t
		" . ($idTabela > 0 ? " WHERE t.idTabela = " . $idTabela : ""). "
		";
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		return $result;
	}
	
	public function intCountTabela($strTabela) {
		$query = "SELECT COUNT(*) AS `intCount` FROM " . $strTabela;
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		return $result['intCount'];
	}

	public function selectTabelaVariaveis($idTabela = 0, $strSearch = '') {
		//$arrDatabaseTables = $this->arrDatabaseTables("'");
		//t.strName IN (" . implode(',', $arrDatabaseTables). ")
		mysql_set_charset ('utf8', $this->database);
		$query =
		"SELECT " . ($strSearch ? "DISTINCT" : ""). "
			tv.idTabelaVariavel,
			tv.idTabela,
			tv.strVarNome,
			tv.txtVarDescricao,
			t.strName AS `strTabela`
		FROM
			tabelavariavel tv,
			tabela			t
		WHERE 
			t.idTabela = tv.idTabela
		" . ($idTabela > 0	? " AND tv.idTabela = " . $idTabela : ""). "
		" . ($strSearch		? " AND (tv.strVarNome LIKE '%" . $strSearch . "%' OR tv.txtVarDescricao LIKE '%" . $strSearch . "%' OR t.strName LIKE '%" . $strSearch . "%')" : ""). "
		";
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		if ($strSearch) {
			foreach ($result as $i => $item) {
				$result[$i]['blnNumeric']  = $item['strVarNome'][0] == 'V';
				$result[$i]['value'] = '[' . $item['strTabela'] . '] ' . $item['strVarNome'] . ' - ' . $item['txtVarDescricao'];
				$result[$i]['query'] = $strSearch;
			}
			return array('suggestions' => $result);
		}
		return $result;
	}
	
	public function intCountTabelaUF($strTabela, $intUFCod = 0) {
		$query = "SELECT COUNT(*) AS `intCount` FROM " . $strTabela . ($intUFCod > 0 ? " WHERE Cod_setor LIKE '" . $intUFCod . "%'" : "");
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		return $result[0]['intCount'];
	}
	
	public function arrCountTabelaUFs($strTabela) {
		$arrResult = array();
		$arrResult['intTotal'] = 0;
		foreach ($this->arrUFs as $arrUF) {
			$strTableName = $strTabela . '_' . $arrUF['strUF'];
			$query = "SELECT COUNT(Cod_setor) AS `intCount` FROM `" . $strTableName . "`";
			$result = $this->executeQuery($query);
			$result = $this->prepareReturn($result);
			$intCount = $result[0]['intCount'];
			$arrResult[$arrUF['intUFCod']] = $intCount;
			$arrResult['intTotal'] += $intCount;
		}
		return $arrResult;
	}
	
	public function intCountSetorUF($intUFCod) {
		$query = "SELECT COUNT(*) AS `intCount` FROM basico WHERE Cod_Setor LIKE '" . $intUFCod . "%'";
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		return $result[0]['intCount'];
	}
	
	public function arrCountSetorUFs() {
		$arrResult = array();
		$arrResult['intTotal'] = 0;
		foreach ($this->arrUFs as $arrUF) {
			$query = "SELECT COUNT(DISTINCT CD_GEOCODI) AS `intCount` FROM setorvertex_" . $arrUF['strUF'];
			$result = $this->executeQuery($query);
			$result = $this->prepareReturn($result);
			$intCount = $result[0]['intCount'];	
			$arrResult[$arrUF['intUFCod']] = $intCount;
			$arrResult['intTotal'] += $intCount;
		}
		return $arrResult;
	}
	
	public function selectUFs($strUF = '') {
		if (($strUF == 'SP1') || ($strUF == 'SP2')) $strUF = 'SP';
		$query =
		"SELECT
			uf.intUFCod,
			uf.strUF,
			uf.strUFName,
			uf.strFusionTablesID
		FROM
			uf uf
		" . ($strUF ? " WHERE uf.strUF = '" . $strUF . "'": ""). "
		ORDER BY
			uf.strUF
		";
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		return $result;
	}
	
	public function selectGeocodigosByRect($dblLatSW, $dblLngSW, $dblLatNE, $dblLngNE, $intLimitBy, $CD_GEOCODI, $strUF = '', $intUTMZone, $chrHemisphere) {
		set_time_limit(500);
		$arrResult = array();
		$blnIsUTM = strlen(round($dblLatSW)) > 4;
		if ($blnIsUTM) {
			// Convert to Geographic
			$strUTMZone = $intUTMZone . $chrHemisphere;
			$this->rs2->gPoint->setUTM($dblLngSW, $dblLatSW, $strUTMZone);
			$this->rs2->gPoint->convertTMtoLL();
			$dblLngSW = $this->rs2->gPoint->Long();
			$dblLatSW = $this->rs2->gPoint->Lat();
			$this->rs2->gPoint->setUTM($dblLngNE, $dblLatNE, $strUTMZone);
			$this->rs2->gPoint->convertTMtoLL();
			$dblLatNE = $this->rs2->gPoint->Lat();
			$dblLngNE = $this->rs2->gPoint->Long();
		}
		if ($intLimitBy == 1) { // Rectangle
			$query =
			"SELECT DISTINCT 
				sv.CD_GEOCODI
			FROM
				setorvertex" . ($strUF ? '_' . $strUF : '') . "	sv
			WHERE 
				sv.dblLatitude	< '" . $dblLatNE . "' AND 
				sv.dblLongitude	< '" . $dblLngNE . "' AND 
				sv.dblLatitude	> '" . $dblLatSW . "' AND
				sv.dblLongitude	> '" . $dblLngSW . "'
			";
		} else if ($intLimitBy == 2) { // Municipio
			if (! $CD_GEOCODI > 0) {
				$dblLatC = ($dblLatNE + $dblLatSW)/2;
				$dblLngC = ($dblLngNE + $dblLngSW)/2;
				$dblRadiusDegrees = 1000/110000; // 1000 meters
				$query =
				"SELECT DISTINCT
					sv.CD_GEOCODI
				FROM
					setorvertex" . ($strUF ? '_' . $strUF : '') . "	sv
				WHERE 
					sv.dblLatitude	< '" . ($dblLatC + $dblRadiusDegrees) . "' AND 
					sv.dblLongitude	< '" . ($dblLngC + $dblRadiusDegrees) . "' AND 
					sv.dblLatitude	> '" . ($dblLatC - $dblRadiusDegrees) . "' AND
					sv.dblLongitude	> '" . ($dblLngC - $dblRadiusDegrees) . "'
				LIMIT 1
				";
				$result = $this->executeQuery($query);
				$result = $this->prepareReturn($result);
				$CD_GEOCODI = substr($result[0]['CD_GEOCODI'], 0, 7);
			}
			$COD_MUNICIPIO = substr($CD_GEOCODI, 0, 7);
			if (! $COD_MUNICIPIO > 0) { return $arrResult; }
			$query =
			"SELECT DISTINCT
				Cod_setor AS CD_GEOCODI
			FROM
				basico" . ($strUF ? '_' . $strUF : '') . "
			WHERE 
				Cod_municipio = " . $COD_MUNICIPIO . "
			";
		}
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		foreach($result as $item) {
			$arrResult[] = $item['CD_GEOCODI'];
		}
		return $arrResult;
	}
	
	public function selectMunicipioByPoint($dblLatitude, $dblLongitude, $strUF) {
		set_time_limit(500);
		$strUF = strtolower($strUF);
		$dblRadiusDegrees = 1000/110000; // 1000 meters
		$query =
		"SELECT
			sv.CD_GEOCODI,
			b.Nome_do_municipio AS NM_MUNICIP
		FROM
			basico_" . $strUF . " b,
			setorvertex_" . $strUF . " sv 
		WHERE 
			sv.CD_GEOCODI = b.Cod_setor AND
			sv.dblLatitude	< '" . ($dblLatitude + $dblRadiusDegrees) . "' AND 
			sv.dblLongitude	< '" . ($dblLongitude + $dblRadiusDegrees) . "' AND 
			sv.dblLatitude	> '" . ($dblLatitude - $dblRadiusDegrees) . "' AND
			sv.dblLongitude	> '" . ($dblLongitude - $dblRadiusDegrees) . "'
		LIMIT 1
		";
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		return $result[0];
	}
	
	public function selectSetoresByRect($dblLatSW, $dblLngSW, $dblLatNE, $dblLngNE, $intLimitBy, $CD_GEOCODI, $strUF, $intUTMZone, $chrHemisphere) {
		$arrGeocodigos = $this->selectGeocodigosByRect($dblLatSW, $dblLngSW, $dblLatNE, $dblLngNE, $intLimitBy, $CD_GEOCODI, $strUF, $intUTMZone, $chrHemisphere);
		$query = "
		SELECT
			sv.CD_GEOCODI,
			sv.intPart,
			sv.dblLatitude, 
			sv.dblLongitude
		FROM
			setorvertex" . ($strUF ? '_' . $strUF : '') . "	sv
		WHERE 
			sv.CD_GEOCODI IN (" . implode(',', $arrGeocodigos) . ")
		ORDER BY 
			sv.idSetorVertex
		";
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		$arrSetores = array();
		$arrVertexs = array();		
		$j=-1;
		$CD_GEOCODI = '';
		foreach($result as $i => $item) {
			if ($arrSetores[$j]['CD_GEOCODI'] != $item['CD_GEOCODI']) {
				$j++;
			}
			$arrSetores[$j]['CD_GEOCODI'] = $item['CD_GEOCODI'];
			$arrSetores[$j]['arrVertexs'][$item['intPart']][] = array(
				'intPart' => $item['intPart'],
				'dblLatitude' => $item['dblLatitude'],
				'dblLongitude' => $item['dblLongitude']
			);
		}
		return $arrSetores;
	}
	
	public function selectDadosTabelas($strExt, $arrGeocodigos, $strVars, $strUF){
		$arrTabelas = array();
		$arrTabelaVariavel = json_decode($strVars, true);
		$query = "SELECT `" . strtolower($arrTabelaVariavel[0]['strTabela'] . '_' . $strUF) . "`.`Cod_setor`,";
		$strTitulo = '';
		$strAS = '';
		foreach ($arrTabelaVariavel as $i => $item) {	
			if ($item['intOperator'] == 1) {
				$chrOperator = '+';
			} else if ($item['intOperator'] == 2) {
				$chrOperator = '-';
			} else if ($item['intOperator'] == 3) {
				$chrOperator = '*';
			} else if ($item['intOperator'] == 4) {
				$chrOperator = '/';
			} else {
				$chrOperator = ',';
			}
			$strAS .= '[' . $item['strTabela'] . '] ' . $item['strVarNome'] . ($chrOperator != ',' ? $chrOperator : '');
			$strTabelaNome = strtolower($item['strTabela'] . '_' . $strUF);
			$query .= '`' . $strTabelaNome . '`.`' . $item['strVarNome'] . '`';
			if (($strExt != 'DBF') && ($strExt != 'SHP') && ($chrOperator == ',')) {
			  $query .= 'AS `' . $strAS . '`';
			  $strAS = '';
			}
			$query .= ($i < count($arrTabelaVariavel) - 1 ? $chrOperator : '');
			if (array_search($strTabelaNome, $arrTabelas) === FALSE) $arrTabelas[] = $strTabelaNome;
		}
		$strWhere = '';
		if (count($arrTabelas) > 1) {
			for($i=1;$i<count($arrTabelas);$i++) {
				$strWhere .= '`' . strtolower($arrTabelas[0]) . "`.Cod_setor=`" . strtolower($arrTabelas[$i]) . "`.Cod_setor AND ";
			}
		}
		$query .= " FROM " . strtolower(implode(',', $arrTabelas)) . " WHERE " . $strWhere . " " . strtolower($arrTabelas[0]) . ".Cod_setor IN (" . implode(',', $arrGeocodigos) . ")";
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		$arrResult = array();
		foreach ($result as $item) {
			$arrResult[$item['Cod_setor']] = $item;
		}
		return $arrResult;
	}

	public function dataExport($strExt, $dblLatSW, $dblLngSW, $dblLatNE, $dblLngNE, $intUTMZone, $chrHemisphere, $dblResolution, $strVars = '', $intLimitBy, $CD_GEOCODI, $strUF = '', $idUser = 0, $database = null) {
		set_time_limit(300);
		$arrOutput = array();
		$arrOutput['strFilePath'] = $this->strOutputFileName . '.' . strtolower($strExt);
		$strTmpFilePathNoExt = $this->strings->strSiteTmpFileFolder . '/' . date('d-m-y-H-i-s');
		$arrOutput['strFilePathTMP'] = $strTmpFilePathNoExt . '.' . strtolower($strExt);
		// Setores Censitrios Shape Information
		if (($strExt == 'SHP') || ($strExt == 'KML') || ($strExt == 'RS2') || ($strExt == 'PRJ')) {
			$arrSetores = $this->selectSetoresByRect($dblLatSW, $dblLngSW, $dblLatNE, $dblLngNE, $intLimitBy, $CD_GEOCODI, $strUF, $intUTMZone, $chrHemisphere);
			$arrGeocodigos = array();
			foreach ($arrSetores as $arrSetor) {
				$arrGeocodigos[] = $arrSetor['CD_GEOCODI'];
			}
		} else {
			$arrGeocodigos = $this->selectGeocodigosByRect($dblLatSW, $dblLngSW, $dblLatNE, $dblLngNE, $intLimitBy, $CD_GEOCODI, $strUF, $intUTMZone, $chrHemisphere);
		}
		// Tabular Data
		if (($strVars) && ($strExt != 'RS2')) {
			$arrLinhas = $this->selectDadosTabelas($strExt, $arrGeocodigos, $strVars, $strUF);
			if (! count($arrLinhas)) {
				$arrLinhas = array();
				foreach ($arrGeocodigos as $CD_GEOCODI) {
					$arrLinhas[$CD_GEOCODI]['CD_GEOCODI'] = $CD_GEOCODI;
				}
			}
		}
		switch ($strExt) {
		// Export to Map
		case "SHP":
			$arrBBox = $this->getBoundingBox($arrSetores);
			$shp = new ShapeFile(5, array("xmin" => $arrBBox['dblLngSW'], "ymin" => $arrBBox['dblLatSW'], "xmax" => $arrBBox['dblLngNE'], "ymax" => $arrBBox['dblLatNE']));
			$arrFields = $this->arrDBFFields($arrLinhas, $strExt);
			$dbf = XBaseWritableTable::create($strTmpFilePathNoExt . '.dbf', $arrFields);
			foreach($arrSetores as $arrSetor) {
				$this->shpInsertObject($arrSetor, $shp, $dbf, $arrLinhas);
			}
			$shp->saveToFile($strTmpFilePathNoExt . '.*');
			$dbf->close();			
			$zip = new ZipArchive();
			$zip->open($strTmpFilePathNoExt . '.zip', ZIPARCHIVE::CREATE);
			$zip->addFile($strTmpFilePathNoExt . '.shp', $this->strOutputFileName . '.shp');
			$zip->addFile($strTmpFilePathNoExt . '.shx', $this->strOutputFileName . '.shx');
			$zip->addFile($strTmpFilePathNoExt . '.dbf', $this->strOutputFileName . '.dbf');
			$zip->close();
			$arrOutput['strFilePathTMP'] = $strTmpFilePathNoExt . '.zip';
			$arrOutput['strFilePath'] = $this->strOutputFileName . '.zip';
		break;
		case "KML":
			$strPlaces = '';
			$strStyles = '';
			foreach ($arrSetores as $arrSetor) {
				$strRGB = $this->strings->strSwapRGBToBGR($this->strings->strGenerateRandonColor()); // 7f (50%) = Opacity - [00..FF]
				$strDescription = '';
				foreach ($arrLinhas[$arrSetor['CD_GEOCODI']] as $strFieldName => $strValor) {
					$strDescription .= '<b>' . $strFieldName . ':</b> ' . $strValor . '<br>';
				}
				$strPlaces .= '<Placemark><name>' . $arrSetor['CD_GEOCODI'] . '</name><description><![CDATA[' . $strDescription. ']]></description>';
				$strStyles .= '
					<Style id="style-' . $arrSetor['CD_GEOCODI'] . '"><LineStyle><width>3.5</width><color>ff' . $strRGB . '</color></LineStyle><PolyStyle><color>7f' . $strRGB . '</color></PolyStyle></Style>
					<StyleMap id="mstyle-' . $arrSetor['CD_GEOCODI'] . '"><Pair><key>normal</key><styleUrl>#style-' . $arrSetor['CD_GEOCODI'] . '</styleUrl></Pair><Pair><key>highlight</key><styleUrl>#style-' . $arrSetor['CD_GEOCODI'] . '</styleUrl></Pair></StyleMap>
				';				
				// Inserting Vertexes
				$strPolygon = '';
				foreach($arrSetor['arrVertexs'] as $i => $arrPart) {
					$strVertexs = '';
					$strBoundaryIs = ($i == 0 ? 'outerBoundaryIs' : 'innerBoundaryIs');
					foreach($arrPart as $arrVertex) {
						$strVertexs .= $arrVertex['dblLongitude'] . ',' . $arrVertex['dblLatitude'] . " ";
					}
					$strPolygon .= '
						<' . $strBoundaryIs .'>
						  <LinearRing>
							  <altitudeMode>clampToGround</altitudeMode>
							  <coordinates>' . $strVertexs . '</coordinates>
						  </LinearRing>
					  </' . $strBoundaryIs .'>
					';
				}
				$strPlaces .= '	
					<styleUrl>#mstyle-' . $arrSetor['CD_GEOCODI'] . '</styleUrl>' . 
					(count($arrSetor['arrVertexs']) > 1 ? '<MultiGeometry>' : '') . 
					'<Polygon><altitudeMode>clampToGround</altitudeMode>' .
						$strPolygon .
					'</Polygon>' . 
					(count($arrSetor['arrVertexs']) > 1 ? '</MultiGeometry>' : '') . 
					'</Placemark>
				';
			} // End of Setores
			$strOut = '<?xml version="1.0" encoding="UTF-8"?>
				<kml xmlns="http://www.opengis.net/kml/2.2" xmlns:gx="http://www.google.com/kml/ext/2.2" xmlns:kml="http://www.opengis.net/kml/2.2" xmlns:atom="http://www.w3.org/2005/Atom">
					<Document>
						<open>1</open>
						<name>Setores Censitrios (' . count($arrSetores) . ')</name>' . $strStyles . $strPlaces . '
					</Document>
				</kml>
			';
			$fh = fopen($arrOutput['strFilePathTMP'], 'w');
			fwrite($fh, $strOut);
			fclose($fh);
		break;
		case "RS2":
			$arrBBox = array();
			$arrDimensions = array();
			$blnIsUTM = strlen(round($dblLatSW)) > 4;
			// Setting Map Width
			if ($blnIsUTM) {
				$arrBBox['dblLatSWUTM'] = $dblLatSW;
				$arrBBox['dblLngSWUTM'] = $dblLngSW; 
				$arrDimensions['dblWidthMts']	= abs($dblLngSW - $dblLngNE);
				$arrDimensions['dblHeightMts'] 	= abs($dblLatSW - $dblLatNE);
				// Convert to Geographic
				$strUTMZone = $intUTMZone . $chrHemisphere;
				$this->rs2->gPoint->setUTM($dblLngSW, $dblLatSW, $strUTMZone);
				$this->rs2->gPoint->convertTMtoLL();
				$arrBBox['dblLngSW'] = $this->rs2->gPoint->Long();
				$arrBBox['dblLatSW'] = $this->rs2->gPoint->Lat();
				$this->rs2->gPoint->setUTM($dblLngNE, $dblLatNE, $strUTMZone);
				$this->rs2->gPoint->convertTMtoLL();
				$arrBBox['dblLatNE'] = $this->rs2->gPoint->Lat();
				$arrBBox['dblLngNE'] = $this->rs2->gPoint->Long();
			} else {
				$arrBBox['dblLatSW'] = $dblLatSW;
				$arrBBox['dblLngSW'] = $dblLngSW;
				$arrBBox['dblLatNE'] = $dblLatNE;
				$arrBBox['dblLngNE'] = $dblLngNE;
				// Setting BoundingBox in UTM
				$this->rs2->gPoint->setLongLat($arrBBox['dblLngSW'], $arrBBox['dblLatSW']);
				$this->rs2->gPoint->convertLLtoTM();
				$arrBBox['dblLatSWUTM'] = $this->rs2->gPoint->N();
				$arrBBox['dblLngSWUTM'] = $this->rs2->gPoint->E();
				$arrBBox['intZoneSWUTM'] = $this->rs2->gPoint->Z();
				$this->rs2->gPoint->setLongLat($arrBBox['dblLngSW'], $arrBBox['dblLatSW']);
				$arrDimensions['dblWidthMts']	= ceil($this->rs2->gPoint->distanceFrom($arrBBox['dblLngNE'], $arrBBox['dblLatSW']));
				$arrDimensions['dblHeightMts'] 	= ceil($this->rs2->gPoint->distanceFrom($arrBBox['dblLngSW'], $arrBBox['dblLatNE']));
			}
			$arrDimensions['dblResolution'] = $dblResolution;
			$arrDimensions['intWidthPixels'] = round($arrDimensions['dblWidthMts'] / $arrDimensions['dblResolution']);
			$arrDimensions['intHeightPixels'] 	= round($arrDimensions['dblHeightMts'] / $arrDimensions['dblResolution']);			
			// Creating Image and Ploting
			$image		= imagecreatetruecolor($arrDimensions['intWidthPixels'], $arrDimensions['intHeightPixels']);
			$imgWhite	= ImageColorAllocate($image, 255, 255, 255);
			$imgBlack	= ImageColorAllocate($image, 0, 0, 0);
			imagefilledrectangle($image, 0, 0, $arrDimensions['intWidthPixels'], $arrDimensions['intHeightPixels'], $imgWhite);
			$j=0;
			$arrClasses = array();
			foreach ($arrSetores as $j => $arrSetor) {				
				$strRGB = $this->strings->strColorConvertDecToRGB($j+1); 
				$imgColor = ImageColorAllocate($image, $strRGB['R'], $strRGB['G'], $strRGB['B']);
				foreach($arrSetor['arrVertexs'] as $arrPart) {
					$arrPts = array();
					foreach($arrPart as $i => $arrVertex) {
						$arrXY = $this->rs2->convertLatLngToXY($arrVertex['dblLatitude'], $arrVertex['dblLongitude'], $arrDimensions['dblResolution'], $arrBBox);
						array_push($arrPts, $arrXY['X']);
						array_push($arrPts, $arrXY['Y']);
					}
					imagefilledpolygon($image, $arrPts, count($arrPart), $imgColor);
				}
				$arrClasses[$j]['strClass'] = $arrSetor['CD_GEOCODI'];
				$strRGB = $this->strings->strGenerateRandonColor();
				$intColor = hexdec(substr($strRGB, 1, 6));
				$arrClasses[$j]['intColor'] = ($j == 0 ? hexdec("FFFFFF") : $intColor);
			}
			//	imagepng($image, 'tmp/a.png'); // Est plotando com erro o png
			$this->rs2->create(
				$arrOutput['strFilePathTMP'], 
				$this->strFormName, 
				'', 
				$arrDimensions['dblResolution'], 
				round($arrBBox['dblLatSWUTM']), 
				round($arrBBox['dblLngSWUTM']), 
				$intUTMZone, 
				($chrHemisphere == 'N' ? 0 : 1), 
				$arrDimensions['intHeightPixels'], 
				$arrDimensions['intWidthPixels'], 
				$arrClasses, 
				$image
			);
		break;
		case "PRJ":
			include_once 'user.php';
			$user = new User($database);
			include_once 'form.php';
			$form = new Form($database);
			include_once 'formrecord.php';
			$formrecord = new Formrecord($database);
			// Select User
			$arrUser = $user->selectUsers(0, $idUser);
			$arrUser = $arrUser[0];
			// Create Form
			$idForm = $form->insertForm($idUser, $arrUser['idProject'], $this->strFormName);
			$idForm = $idForm['idForm'];
			// Insert Form Fields
			$arrFields = $this->arrDBFFields($arrLinhas, $strExt);
			$i = 1;
			foreach ($arrFields as $arrField) {
				$form->insertFormField($idForm, $arrField[1] == DBFFIELD_TYPE_NUMERIC ? 2 : 1, $arrField[0], '', $i);
				$i++;
			}
			$arrFormFields = $form->selectFormFields($idForm);
			// Get next free idFormRecord to start batch insert
			$idFormRecord = $database->intSelectNextTableKey('formrecord', 'idFormRecord');
			// Get next free idFormRecordField to start batch insert
			$idFormRecordField = $database->intSelectNextTableKey('formrecordfield', 'idFormRecordField');
			$strInsertFormRecord = '';
			$strInsertFormRecordField = '';
			$strInsertFormRecordFieldText = '';
			$strInsertFormRecordFieldNumeric = '';
			// Insert Form Records
			foreach ($arrSetores as $i => $arrSetor) {
				// Insering record into formrecord table
				$strInsertFormRecord .= "(" . $idFormRecord . "," . $idUser . "," . $idForm . ",1,3,'" . $this->strings->strGenerateRandonColor() . "',NOW(),NOW()),";				
				$arrCoordinates = array();
				foreach($arrSetor['arrVertexs'][0] as $j => $arrVertex) {
					$arrInsertRecordVertex[] = "(" . $idFormRecord . ",'" . $arrVertex['dblLatitude'] . "','" . $arrVertex['dblLongitude'] . "', " . ($j+1) .")";
				}
				//$arrFormRecord = $formrecord->insertFormRecord($idUser, $idForm, 1, 3, $this->strings->strGenerateRandonColor(), $arrCoordinates);
				//$idFormRecord = $arrFormRecord['idFormRecord'];
				foreach ($arrFormFields as $j => $arrFormField) {
					$strValue = $arrLinhas[$arrSetor['CD_GEOCODI']][$arrFormField['strName']];
					if ($arrFormField['idFormFieldType'] == 1) {
					  //$formrecord->insertFormRecordFieldText($idFormRecord, $arrFormField['idFormField'], $strValue);
					  $strValue = mb_strtoupper($strValue);
					  if ($strValue) {
						  $strInsertFormRecordField .= "(" . $idFormRecordField . "," . $arrFormField['idFormField']  . "," . $idFormRecord . "),";
						  $strInsertFormRecordFieldText .= "(" . $idFormRecordField . ",'" . $strValue . "'),";
						  $idFormRecordField++;
					  }
					} else if ($arrFormField['idFormFieldType'] == 2) {
						//$formrecord->insertFormRecordFieldNumeric($idFormRecord, $arrFormField['idFormField'], $strValue);
						if (! is_numeric($strValue)) $strValue = '-1';
						$strInsertFormRecordField .= "(" . $idFormRecordField . ",". $arrFormField['idFormField']  . "," . $idFormRecord . "),";
						$strInsertFormRecordFieldNumeric .= "(" . $idFormRecordField . "," .  $strValue . "),";
						$idFormRecordField++;
					}
				}

				if (($i % 100 == 0) || ($i == count($arrSetores)-1)) {
					$strInsertFormRecord = substr($strInsertFormRecord, 0, strlen($strInsertFormRecord) - 1);
					if ($strInsertFormRecord) {
						$strInsertFormRecord = "INSERT INTO formrecord (idFormRecord, idUser, idForm, idDevice, idShapeType, strCustomMarkerRGBColor, dtCreation, dtLastUpdate) VALUES " . $strInsertFormRecord;
						$database->executeQuery($strInsertFormRecord);
						$strInsertFormRecord = '';        
					}
			
					if (count($arrInsertRecordVertex)) {
						// Break Inserts into batches of 1000
						$intIndex = 0;
						while ($intIndex < count($arrInsertRecordVertex)) {
							$arrInsert = array_slice($arrInsertRecordVertex, $intIndex, 1000);
							$intIndex += 1000;
							$database->executeQuery("INSERT INTO formrecordvertex (idFormRecord, dblLatitude, dblLongitude, intPosition) VALUES " . implode(',', $arrInsert));
						}
						$arrInsertRecordVertex = array();
					}
					
					$strInsertFormRecordField = substr($strInsertFormRecordField, 0, strlen($strInsertFormRecordField) - 1);
					if ($strInsertFormRecordField) {
						$strInsertFormRecordField = "INSERT INTO formrecordfield (idFormRecordField, idFormField, idFormRecord) VALUES " . $strInsertFormRecordField;
						$database->executeQuery($strInsertFormRecordField);
						$strInsertFormRecordField = '';
					}

					$strInsertFormRecordFieldText = substr($strInsertFormRecordFieldText, 0, strlen($strInsertFormRecordFieldText) - 1);
					if ($strInsertFormRecordFieldText) {
						$strInsertFormRecordFieldText = "INSERT INTO formrecordfieldtext (idFormRecordField, strValue) VALUES " . $strInsertFormRecordFieldText;
						$database->executeQuery($strInsertFormRecordFieldText);
						$strInsertFormRecordFieldText = '';
					}
					
					$strInsertFormRecordFieldNumeric = substr($strInsertFormRecordFieldNumeric, 0, strlen($strInsertFormRecordFieldNumeric) - 1);
					if ($strInsertFormRecordFieldNumeric) {
						$strInsertFormRecordFieldNumeric = "INSERT INTO formrecordfieldnumeric (idFormRecordField, dblValue) VALUES " . $strInsertFormRecordFieldNumeric;
						$database->executeQuery($strInsertFormRecordFieldNumeric);
						$strInsertFormRecordFieldNumeric = '';
					}
				}
				$idFormRecord++;
			}
		break;
		// Export Data Tables
		case "XLSX":
			include_once('js/excel/Classes/PHPExcel.php');
			$workbook = new PHPExcel();	
			$worksheet = $workbook->getActiveSheet();
			$workbook->setActiveSheetIndex(0);
			$arrColTypes = array();
			$arrColTypes[0] = 1;
			$intRow = 0;
			foreach ($arrLinhas as  $arrLinha) {
				$intCol = 0;
				foreach ($arrLinha as $strFieldName => $strValor) {
					$strValor = utf8_encode($strValor);
					// Change -1 for VOID
					$strValor = str_replace('-1', $this->chrNoValue, $strValor);
					if ($intRow == 0) {
						$workbook->getActiveSheet()->setCellValueByColumnAndRow($intCol, $intRow+1, $strFieldName);
						$arrColTypes[] = is_numeric($strValor) ? 2 : 1;
					} 
					if ($intCol == 0) {
						$workbook->getActiveSheet()->setCellValueExplicitByColumnAndRow($intCol, $intRow+2, $strValor);
					} else {
						$workbook->getActiveSheet()->setCellValueByColumnAndRow($intCol, $intRow+2, $strValor);
					}
					$intCol++;
				}
				$intRow++;
			}
			$objworkbook = PHPExcel_IOFactory::createWriter($workbook, 'Excel2007');
			$objworkbook->save($arrOutput['strFilePathTMP']);
			/*
			// Excel 1995
			require_once "js/excelwriter/class.writeexcel_workbookbig.inc.php";
			require_once "js/excelwriter/class.writeexcel_worksheet.inc.php";
			$workbook = new writeexcel_workbookbig($arrOutput['strFilePathTMP']);
			$worksheet = $workbook->addworksheet($this->strFormName);
			$ftHeader = &$workbook->addformat();
			$ftHeader->set_bold();
			$ftHeader->set_align('center');
			$ftHeader->set_align('vcenter');
			$ftHeader->set_color(0x09); // White
			$ftHeader->set_bg_color(0x17); // Gray
			$ftHeader->set_size(10);
			// Format Col 0 (GEOCODIGO) as TEXT
			$ftCell = &$workbook->addformat(array(num_format => '@'));
			foreach ($arrLinhas as $intRow => $arrLinha) {
				$intCol = 0;
				foreach ($arrLinha as $strFieldName => $strValor) {
					if ($intRow == 0) {
						$worksheet->write($intRow, $intCol, $strFieldName, $ftHeader);
					}
					$worksheet->write($intRow + 1, $intCol, $strValor, $intCol == 0 ? $ftCell : NULL);
					$intCol++;
				}
			}
			$worksheet->freeze_panes(1, 0); // Freeze Row 1
			$workbook->close();
			*/
		break;
		case "DBF":
			$arrFields = $this->arrDBFFields($arrLinhas, $strExt);
			$dbf = XBaseWritableTable::create($arrOutput['strFilePathTMP'], $arrFields);
			// Inserting Records
			foreach ($arrLinhas as $arrLinha) {
				$r =& $dbf->appendRecord();
				$i=0;
				foreach ($arrLinha as $strValor) {
					$strValor = $this->strings->removeInvalidChars($strValor);
					$r->setObjectByName($arrFields[$i][0], $strValor);
					$i++;
				}
				$dbf->writeRecord();
			}
			$dbf->close();
		break;
		case "CSV":
			$intRow=0;
			$arrHeader = array();
			// CSV Header - Fields Name - First Row
			foreach (reset($arrLinhas) as $strFieldName => $strValor) {
				$arrHeader[] = $strFieldName;
			}
			$strCSV = implode(';', $arrHeader) . chr(13);
			foreach ($arrLinhas as $strFieldName => $arrLinha) {
				$arrValues = array();
				foreach ($arrLinha as $strValor) {
					// Change -1 for VOID
					$strValor = str_replace('-1', $this->chrNoValue, $strValor);
					$arrValues[] = $strValor;
				}
				$strCSV .= implode(';', $arrValues) . ($intRow < count($arrLinhas) - 1 ? chr(13) : '');
				$intRow++;
			}
			$fh = fopen($arrOutput['strFilePathTMP'], 'w');
			fwrite($fh, $strCSV);
			fclose($fh);
		break;
		}
		return $arrOutput;
	}

  private function arrDBFFields($arrLinhas, $strExt) {
	$arrFields = array();
	// Creating Table and Defining Fields Names and Types
	if ($strExt == 'SHP') {
		$arrFields[] = array("FID", DBFFIELD_TYPE_NUMERIC, 8, 0);
	}
	$i=1;
	foreach (reset($arrLinhas) as $strFieldName => $strValor) {
		if ((($strExt == 'DBF') || ($strExt == 'SHP')) && ($strFieldName != 'Cod_setor')) {
			$arrFieldName = explode('-', $this->strings->strDBFFieldName($strFieldName));
			$strFieldName = trim($arrFieldName[0]);
			$strFieldName = $i . '_'. $strFieldName;
		}
		if ((is_numeric($strValor)) && (strlen($strValor) < 13)) {
			$arrFields[] = array($strFieldName, DBFFIELD_TYPE_NUMERIC, 13, 2);
		} else {
			$arrFields[] = array($strFieldName, DBFFIELD_TYPE_CHAR, 254);
		}
		//$arrFields[] = array($strFieldName, DBFFIELD_TYPE_CHAR, 254);
		$i++;
	}
	return $arrFields;
  }

	public function shpInsertObject($arrSetor, &$shp, &$dbf, $arrLinhas) {
		// SHP Record
		$shpRecord = new ShapeRecord(5);
		foreach($arrSetor['arrVertexs'] as $arrPart) {
			$shpRecord->addPoint(array("x" => $arrPart[count($arrPart)-1]['dblLongitude'], "y" => $arrPart[count($arrPart)-1]['dblLatitude']), $arrPart[0]['intPart']);
			foreach($arrPart as $arrVertex) {
				$shpRecord->addPoint(array("x" => $arrVertex['dblLongitude'], "y" => $arrVertex['dblLatitude']), $arrVertex['intPart']);
			}
		}
		$intID = $shp->addRecord($shpRecord);
		// DBF Record
		$r =& $dbf->appendRecord();
		$r->setObjectByIndex(0, $intID); // FID
		$i=1;
		foreach ($arrLinhas[$arrSetor['CD_GEOCODI']] as $strValor) {
			$strValor = $this->strings->removeInvalidChars($strValor);
			$r->setObjectByIndex($i, $strValor);
			$i++;
		}
		$dbf->writeRecord();
	}
		
	public function getBoundingBox($arrSetores) {
		$arrBBox = array();
		$arrBBox['dblLatSW'] = 90;
		$arrBBox['dblLngSW'] = 180;
		$arrBBox['dblLatNE'] = -90;
		$arrBBox['dblLngNE'] = -180;
		foreach ($arrSetores as $arrSetor) {
			foreach($arrSetor['arrVertexs'] as $arrPart) {
				foreach ($arrPart as $arrVertex) {
					if ($arrVertex['dblLatitude']   < $arrBBox['dblLatSW']) $arrBBox['dblLatSW'] = $arrVertex['dblLatitude'];
					if ($arrVertex['dblLongitude']  < $arrBBox['dblLngSW']) $arrBBox['dblLngSW'] = $arrVertex['dblLongitude'];
					if ($arrVertex['dblLatitude']   > $arrBBox['dblLatNE']) $arrBBox['dblLatNE'] = $arrVertex['dblLatitude'];
					if ($arrVertex['dblLongitude']  > $arrBBox['dblLngNE']) $arrBBox['dblLngNE'] = $arrVertex['dblLongitude'];
				}
			}
		}
		return $arrBBox;
	}
	
	/* Database Procedures */
	public function executeQuery($query) {
		$result = mysql_query($query, $this->database);
		$this->setLastErr();
		return $result;
	}

	public function getLastErr() {
		return $this->lastErr;
	}

	private function setLastErr() {
		$this->lastErr = mysql_error($this->database);
	}
	
	public function getLastInsertedID() {
		return mysql_insert_id($this->database);
	}

	public function getNumAffectedRows() {
		return mysql_affected_rows($this->database);
	}

	public function arrDatabaseTables($strChar = '') {
		$query = "SHOW TABLES FROM `" . $this->mydb . "`";
		$result = $this->executeQuery($query);
		$arrTables = array();
		while(($linha = mysql_fetch_array($result)) != null) {
			$arrTables[] = $strChar . $linha[0] . $strChar;
		}
		return $arrTables;
	}
	
	public function prepareReturn($resultado) {
		if($this->getLastErr() == null) {
			$retorno = Array();
			while(($linha = mysql_fetch_array($resultado)) != null) {
				$aux = Array();
				foreach($linha as $chave2 => $valor2) {
					if(!is_numeric($chave2)) {
						$aux[$chave2] = $valor2;
					}
				}
				$retorno[] = $aux;
			}
			return $retorno;
		} else {
			return null;
		}
	}	
	
	/* Import Procedures */
	public function importMalhaSetores($strUF) {
		set_time_limit(6000);
		$strSHPFilePathNoExt = $this->strSHPDir . '/' . $strUF;
		$arrResult = $this->arrReadInsertSHP($strSHPFilePathNoExt, false, $strUF);
		return $arrResult;
	}
		
	public function arrReadInsertSHP($strSHPFilePathNoExt, $blnReadDBF = false, $strUF){
		$this->load($strSHPFilePathNoExt . '.shp', $strUF);
		return array ('intRecords' => count($this->getShapeData()));
	}

	public function clearMalhaSetores() {
		$intDeleted = 0;
		foreach ($this->arrUFs as $arrUF) {
			$this->executeQuery('CREATE TABLE IF NOT EXISTS `setorvertex_' . $arrUF['strUF'] . '` (`idSetorVertex` INT UNSIGNED NOT NULL AUTO_INCREMENT, `CD_GEOCODI` BIGINT NOT NULL, `intPart` TINYINT, `dblLatitude` DOUBLE NULL, `dblLongitude` DOUBLE NULL, PRIMARY KEY (`idSetorVertex`))');
			$this->executeQuery('TRUNCATE setorvertex_' . $arrUF['strUF']);
			$intDeleted += $this->getNumAffectedRows();
		}
		return array('intDeleted' => $intDeleted);
	}
	
	public function importTabelaCSV($idTabela, $strUF) {
		set_time_limit(6000);
		$blnSP2 = $strUF == 'SP2';
		$intRecords = 0;
		$arrTabelas = $this->selectTabelas($idTabela);
		$strTabela = $arrTabelas[0]['strName'];
		$strCSVFilePath = $this->strCSVDir . '/' . $strTabela . '_' . $strUF . '.csv';
		if (! file_exists($strCSVFilePath)) { return array ('intRecords' => 0); } 
		$strFileContent = file_get_contents($strCSVFilePath);
		if (($strUF == 'SP1') || ($strUF == 'SP2')) $strUF = 'SP'; 
		$strTableName = $strTabela . '_' . $strUF;
		$arrUFs = $this->selectUFs($strUF);
		$intUFCod = $arrUFs[0]['intUFCod'];
		$arrLines = explode(chr(13), $strFileContent);
		$strLineHeader = $arrLines[0];
		$strLineHeader = $this->strings->changeCharAccent($strLineHeader);
		$strLineHeader = $this->strRemoveInvalidCharsSQL($strLineHeader);
		$arrHeader = explode(';', $strLineHeader);
		$arrFieldNames = array();
		foreach($arrHeader as $intCol => $strFieldName) {
			if (! $strFieldName) continue;			
			$arrFields[$intCol]['strName'] = trim($strFieldName);
			$arrFields[$intCol]['idType'] = (strpos($strFieldName, 'Nome_') !== FALSE ? 1 : 2);
			$arrFields[$intCol]['strType'] = ($arrFields[$intCol]['idType'] == 1 ? 'VARCHAR(100) NULL' : 'INT');
			if ($intCol == 0) { // PK
				$arrFields[$intCol]['strType'] = 'BIGINT NOT NULL AUTO_INCREMENT';
			}
			$arrFieldNames[] = '`' . $arrFields[$intCol]['strName'] . '`';
		}
		$this->createTabelaFromCSV($strTableName, $arrFields);
		if (! $blnSP2) {
			$this->deleteTabelaUF($strTableName);
		}
		$arrInserts = array();
		$intInserted = 0;
		for($intRow=1;$intRow<count($arrLines);$intRow++) {
			if (($intRow % 500 == 0) || ($intRow == count($arrLines)-1)) { // Do not increase over 200 to avoid memory overflow
				$strSQL = "INSERT INTO `" . $strTableName . "` (" . implode(',',  $arrFieldNames) . ") VALUES " . implode(',', $arrInserts);
				$result = $this->executeQuery($strSQL);
				$arrInserts = array();
			}
			$strRow = $this->strRemoveInvalidCharsSQL($arrLines[$intRow]);
			if (! $strRow) continue;
			$arrCells = explode(';', $strRow);
			$arrRowValues = array();
			for($intCol=0;$intCol<count($arrFields);$intCol++){
				$strCell = trim($arrCells[$intCol]);
				if (($intCol==0) && (! $strCell)) continue;
				// Replace , by , for Numeric Fields
				if (($intCol > 0) && ($arrFields[$intCol]['idType'] == 2)) {
					$strCell = str_replace(",", '.', $strCell); 
					// Force to INT
					$strCell = round($strCell);
				}
				$arrRowValues[] = "'" . $strCell . "'";
			}
			$arrInserts[] = '(' . implode(',', $arrRowValues) . ')';
			$intInserted++;
		}
		return array ('intRecords' => $intInserted);
	}
	
	public function createTabelaFromCSV($strTabela, $arrFields) {
		foreach ($arrFields as $i => $arrField) {
			$strFields .= '`' . $arrField['strName'] . '` ' . $arrField['strType'] . ($i < count($arrFields) - 1 ? ', ' : '');
		}
		if (! $strFields) return;
		$strSQL = 'CREATE TABLE IF NOT EXISTS `' . $strTabela . '` (' . $strFields . ', PRIMARY KEY (`' . $arrFields[0]['strName'] . '`))';
		$this->executeQuery($strSQL);
	}
	
	public function deleteTabelaUF($strTabela) {
		$strSQL = 'TRUNCATE `' . $strTabela . '`';
		$this->executeQuery($strSQL);
		return array('intDeleted' => $this->getNumAffectedRows());
	}
	
	public function clearTabela($idTabela) {
		$arrTabelas = $this->selectTabelas($idTabela);
		$intDeleted = 0;
		foreach ($this->arrUFs as $arrUF) {
			$strSQL = 'TRUNCATE `' . $arrTabelas[0]['strName'] . '_' . $arrUF['strUF'] . '`';
			$this->executeQuery($strSQL);
			$intDeleted += $this->getNumAffectedRows();
		}
		return array('intDeleted' => $intDeleted);
	}
	
	public function strRemoveInvalidCharsSQL($str) {
		$str = trim($str);
		$str = str_replace('"X"', '-1', $str); // X ==> -1 = UNDEFINED
		$str = str_replace(';X;', ';-1;', $str); // X ==> -1 = UNDEFINED
		$str = str_replace('"', '', $str);
		$str = str_replace("'", '', $str);
		$str = str_replace("(todos os setores)", '', $str);
		$str = str_replace("Municpios no pertencentes a estrutura de RM", '-', $str);
		return $str;
	}	
	
	// Censo SHP Functions
	public function load($path, $strUF) {
		$this->shpFilePath = $path;
		$this->shpFile = fopen($this->shpFilePath, "rb");
		$this->loadHeaders();
		$arrFileName = explode ('.', $path);
		$this->dbf = new dbf_class($arrFileName[0] . '.dbf');
		for($i=0; $i<$this->dbf->dbf_num_field; $i++){
			$this->arrFields[$i]['strName'] = utf8_decode($this->dbf->dbf_names[$i]['name']);
			$this->arrFields[$i]['idType'] = 1; // Set default as text
			if ($this->dbf->dbf_names[$i]['type'] == 'N') {
				$this->arrFields[$i]['idType'] = 2;
			}
		}
		$shpData = $this->loadRecords($strUF);
	}

	public function headerInfo() {
		return $this->headerInfo;
	}
	
	public function getShapeData() {
		return $this->shpData;
	}
	
	private function geomTypes() {
		return array(
		  0  => 'Null Shape',
		  1  => 'Point',
		  3  => 'PolyLine',
		  5  => 'Polygon',
		  8  => 'MultiPoint',
		  11 => 'PointZ',
		  13 => 'PolyLineZ',
		  15 => 'PolygonZ',
		  18 => 'MultiPointZ',
		  21 => 'PointM',
		  23 => 'PolyLineM',
		  25 => 'PolygonM',
		  28 => 'MultiPointM',
		  31 => 'MultiPatch',
		);
	}
	
	private function geoTypeFromID($id) {
		$geomTypes = $this->geomTypes();
		
		if (isset($geomTypes[$id])) {
		  return $geomTypes[$id];
		}
		
		return NULL;
	}
	
	private function loadHeaders() {
		fseek($this->shpFile, 24, SEEK_SET);
		$length = $this->loadData("N");
		fseek($this->shpFile, 32, SEEK_SET);
		$shape_type = $this->geoTypeFromID($this->loadData("V"));
		
		$bounding_box = array();
		$bounding_box["xmin"] = $this->loadData("d");
		$bounding_box["ymin"] = $this->loadData("d");
		$bounding_box["xmax"] = $this->loadData("d");
		$bounding_box["ymax"] = $this->loadData("d");
		
		$this->headerInfo = array(
		  'length' => $length,
		  'shapeType' => array(
			'id' => $shape_type,
			'name' => $this->geoTypeFromID($shape_type),
		  ),
		  'boundingBox' => $bounding_box,
		);
	}
	
	private function loadRecords($strUF = '') {
		if ($strUF) {
			$this->executeQuery('CREATE TABLE IF NOT EXISTS `setorvertex_' . $strUF . '` (`idSetorVertex` INT UNSIGNED NOT NULL AUTO_INCREMENT, `CD_GEOCODI` BIGINT NOT NULL, `intPart` TINYINT, `dblLatitude` DOUBLE NULL, `dblLongitude` DOUBLE NULL, PRIMARY KEY (`idSetorVertex`))');
			$this->executeQuery('TRUNCATE setorvertex_' . $strUF);
		}
		$this->arrInserts = array();
		fseek($this->shpFile, 100);
		while(!feof($this->shpFile)) {
		  $record = $this->loadRecord();
		  if (count($this->arrInserts) > 2000){
			  $strSQL = "INSERT INTO `setorvertex_" . $strUF . "` (CD_GEOCODI, intPart, dblLatitude, dblLongitude) VALUES " . implode(',', $this->arrInserts);
			  $this->executeQuery($strSQL);
			  $this->arrInserts = array();
		  }
		  $this->shpData[] = $record;
		}
	}

	private function loadData($type) {
		$type_length = $this->loadDataLength($type);
		if ($type_length) {
		  $fread_return = fread($this->shpFile, $type_length);
		  if ($fread_return != '') {
			$tmp = unpack($type, $fread_return);
			return current($tmp);
		  }
		}
		return NULL;
	}
	
	private function loadDataLength($type) {
		$lengths = array(
		  'd' => 8,
		  'V' => 4,
		  'N' => 4,
		);
		
		if (isset($lengths[$type])) {
		  return $lengths[$type];
		}
		
		return NULL;
	}
	
	// shpRecord functions.
	private function loadRecord() {
		$recordNumber = $this->loadData("N");
		$this->loadData("N"); // unnecessary data.
		$shape_type = $this->loadData("V");
		$record = array(
		  'shapeType' => array(
			'id' => $shape_type,
			'name' => $this->geoTypeFromID($shape_type),
		  ),
		);
		switch($record['shapeType']['id']){
		  case 0:
			$this->loadNullRecord();
			break;
		  case 5:
			$this->loadPolygonRecord(5, $recordNumber); // For Censo
			break;
		  case 25: // PolygonM
			$this->loadPolygonRecord(25, $recordNumber); // For Censo
			break;
		  default:
			break;
		}
		return $record;
	}
	
	private function loadPoint() {
		$data = array();
		$data['x'] = $this->loadData("d");
		$data['y'] = $this->loadData("d");
		return $data;
	}
	
	private function loadNullRecord() {
		return array();
	}
	
	private function loadPolygonRecord($idShapeType, $recordNumber) {
		$return = array(
		  'bbox' => array(
			'xmin' => $this->loadData("d"),
			'ymin' => $this->loadData("d"),
			'xmax' => $this->loadData("d"),
			'ymax' => $this->loadData("d"),
		  ),
		);
		$row = $this->dbf->getRow($recordNumber-1);
		$CD_GEOCODI = $row[1];
		$object = $this->processLineStrings($idShapeType, $CD_GEOCODI);
	}
	
  /**
   * Process function for loadPolyLineRecord and loadPolygonRecord.
   * Returns geometries array.
   */
  private function processLineStrings($shape_type = 0, $CD_GEOCODI) {
    $numParts = $this->loadData("V");
    $numPoints = $this->loadData("V");
 
	// Integer[NumParts] Parts // Index to First Point in Part (Inteiro com o ndice do primeiro vrtice de cada parte)
    $parts = array();
    for ($i = 0; $i < $numParts; $i++) {
      $parts[] = $this->loadData("V");
    }
	// Stores in last position the number of points. 
	// Eg.: [0,307,312,317,322,327,332] = Part 1 Starts 0 and finishes 306, Part 2 starts 307 and finishes 311,... Part N Starts 327, finishes 331
    $parts[] = $numPoints;

	// Points - Integer x 2 x NPoints
    $points = array();
    for ($i = 0; $i < $numPoints; $i++) {
      $points[] = $this->loadPoint();
	  
    }

	if ($shape_type == 25) { // PolygonM
		//Mmin - Double
		$Mmin = $this->loadData("d");
		//Mmax - Double
		$Mmax = $this->loadData("d");
		for ($i = 0; $i < $numPoints; $i++) {
		  // Marray - Distances between coordinates - Don't store - just read
		  $this->loadData("d");
		}
	} else if ($shape_type == 15) { // PolygonZ
		//Zmin
		$Zmin = $this->loadData("d");
		//Zmax - Double * 1
		$Zmax = $this->loadData("d");
		// Zarray - Double x NPoints
		for ($i = 0; $i < $numPoints; $i++) {
		  // Z Value - Don't store - just read
		  $this->loadData("d");
		}
		//Mmin - Double
		$Mmin = $this->loadData("d");
		//Mmax - Double
		$Mmax = $this->loadData("d");
		for ($i=0;$i<$numPoints;$i++) {
		  // Marray - Distances between coordinates - Don't store - just read
		  $this->loadData("d");
		}
	}
		
	for ($i = 0; $i < $numParts; $i++) {
	  for ($j = $parts[$i]; $j < $parts[$i + 1]; $j++) {		  
		$x = substr($points[$j]['x'],0,10);
		$y = substr($points[$j]['y'],0,10);
		if ((! is_infinite(floatval($x))) && (is_numeric($x)) && (floatval($x) != 0)) {
			$this->arrInserts[] = '(' . $CD_GEOCODI . ',' . ($i) . ',' . $y . ',' . $x . ')';
		}
	  }
	}
	
    return array(
      'numParts' => $numParts,
      'numPoints' => $numPoints
    );
  }
}
?>