<?php
class Correlation {
	public $strDefaultIcon	= 'icon-cog';
	public $strDefaultEquation = '([D]+[T]+[W]+[P])/4';
	public $dblDefaultClusterThreshold = 0.7;
	public $intDefaultDMAX = 500;
	public $intDefaultTMAX = 300;
	public $intProcessLimit = 30;
	
	public function __construct($database) {
		$this->database = $database;

		include_once 'gPoint.php';
		$gPoint = new gPoint($database);
		$this->gPoint = $gPoint;
				
		include_once 'strings.php';
		$strings = new Strings();
		$this->strings = $strings;
		
		include_once 'evalmath.php';
		$evalmath = new EvalMath();
		$this->evalmath = $evalmath;
		$this->evalmath->suppress_errors = true;
		
		include_once 'formrecord.php';
		$formrecord = new Formrecord($database);
		$this->formrecord = $formrecord;
		
		session_start();
	}

	public function report($idProject, $strCIEquation, $dblClusterThreshold, $intDMAX, $intTMAX) {
		set_time_limit(2400); // Increasing Timeout to Garantee Enough Time
		$strOutputTmpFileName = $this->strings->strSiteTmpFileFolder . '/' . $idProject . '-' . date('d-m-Y H-i') . '-' . $this->strings->generateRandomString(2);
		$arrOutput['strFilePathTMP'] = $strOutputTmpFileName . '.xls';
		$arrOutput['strFilePath'] = 'CI.xls';
		require_once "js/excelwriter/class.writeexcel_workbookbig.inc.php";
		require_once "js/excelwriter/class.writeexcel_worksheet.inc.php";
		require_once "js/excelwriter/functions.writeexcel_utility.inc.php"; // Datetime Conversion Function
		$workbook = new writeexcel_workbookbig($arrOutput['strFilePathTMP']);
		// Header 0,0
		$ftHeader0 = &$workbook->addformat();
		$ftHeader0->set_bold();
		$ftHeader0->set_align('left');
		$ftHeader0->set_align('vcenter');
		$ftHeader0->set_color('white');
		$ftHeader0->set_bg_color('gray');
		$ftHeader0->set_size(10);
		// Header Format
		$ftHeader = &$workbook->addformat();
		$ftHeader->set_bold();
		$ftHeader->set_align('center');
		$ftHeader->set_align('vcenter');
		$ftHeader->set_color('white');
		$ftHeader->set_bg_color('gray');
		$ftHeader->set_size(10);
		// Black Cell
		$ftBlack = &$workbook->addformat();
		$ftBlack->set_align('center');
		$ftBlack->set_align('vcenter');
		$ftBlack->set_color('white');
		$ftBlack->set_bg_color('black');
		$ftBlack->set_size(10);
		// Min Cell
		$ftMin = &$workbook->addformat();
		$ftMin->set_align('center');
		$ftMin->set_align('vcenter');
		$ftMin->set_color('black');
		$ftMin->set_bg_color('red');
		$ftMin->set_size(10);
		// Max Cell
		$ftMax = &$workbook->addformat();
		$ftMax->set_align('center');
		$ftMax->set_align('vcenter');
		$ftMin->set_color('white');
		$ftMin->set_bg_color('green');
		$ftMax->set_size(10);
		$worksheet = $workbook->addworksheet('CI');
		$worksheet->write(0, 0, 'CI(m,n) = ' . $strCIEquation, $ftHeader0);		
		$arrFormRecords = $this->formrecord->selectFormRecords($idProject, 0, 0, 0, '', 'idFormRecord', $this->intProcessLimit);		
		for($y=0;$y<count($arrFormRecords);$y++) {
			if ($y > $this->intProcessLimit) break;
			$dblCIMin = 999;
			$dblCIMax = -999;
			//$strValue = $this->strings->strSiteURL . '/' . $arrFormRecords[$x]['idFormRecord'];
			$strValue = $arrFormRecords[$y]['idFormRecord'];
			$worksheet->write($y+1, 0, $strValue, $ftHeader);
			$worksheet->write(0, $y+1, $strValue, $ftHeader);
			for($x=0;$x<count($arrFormRecords);$x++) {
				if ($x > $this->intProcessLimit) break;
				if ($x <= $y) {
					$dblCI = ''; 
					$ftStyle = $ftBlack;
				} else {
					$arrCI = $this->dblCorrelationIndex($arrFormRecords[$x]['idFormRecord'], $strCIEquation, $dblClusterThreshold, $intDMAX, $intTMAX, $arrFormRecords[$y]['idFormRecord']);
					$arrCI = $arrCI[0];
					$dblCI = $arrCI['dblCI'];
					if ($dblCI < $dblCIMin) {
						$intColMin = $x+1;
						$dblCIMin = $dblCI;
					}
					if ($dblCI > $dblCIMax) {
						$intColMax = $x+1;
						$dblCIMax = $dblCI;
					}
					$ftStyle = null;
				}
				$worksheet->write($y+1, $x+1, $dblCI, $ftStyle);
			}
			// Fill as RED MIN CI(m,n)
			//$worksheet->write($y+1, $intColMin, $dblCIMin, $ftMin);
			// Fill as GREEN MAX CI(m,n)
			//$worksheet->write($y+1, $intColMax, $dblCIMax, $ftMax);
		}
		$worksheet->freeze_panes(1, 1); // Freeze
		$workbook->close();
		return $arrOutput;
	}
	
	public function recordReport($idFormRecord, $strCIEquation, $dblClusterThreshold, $intDMAX, $intTMAX) {
		set_time_limit(2400); // Increasing Timeout to Garantee Enough Time
		$strOutputTmpFileName = $this->strings->strSiteTmpFileFolder . '/' . date('d-m-Y H-i') . '-' . $this->strings->generateRandomString(2);
		$arrOutput['strFilePathTMP'] = $strOutputTmpFileName . '.xls';
		$arrOutput['strFilePath'] = 'CI-' . $idFormRecord . '.xls';
		require_once "js/excelwriter/class.writeexcel_workbookbig.inc.php";
		require_once "js/excelwriter/class.writeexcel_worksheet.inc.php";
		require_once "js/excelwriter/functions.writeexcel_utility.inc.php"; // Datetime Conversion Function
		$workbook = new writeexcel_workbookbig($arrOutput['strFilePathTMP']);
		// Header Format
		$ftHeader = &$workbook->addformat();
		$ftHeader->set_bold();
		$ftHeader->set_align('left');
		$ftHeader->set_align('vcenter');
		$ftHeader->set_color('white');
		$ftHeader->set_bg_color('black');
		$ftHeader->set_border_color('black');
		$ftHeader->set_top(1);
		$ftHeader->set_bottom(1);
		$ftHeader->set_left(1);
		$ftHeader->set_right(1);
		$ftHeader->set_size(10);
		// Default Format
		$ftDefault = &$workbook->addformat();
		$ftDefault->set_align('center');
		$ftDefault->set_align('vcenter');
		$ftDefault->set_border_color('black');
		$ftDefault->set_top(1);
		$ftDefault->set_bottom(1);
		$ftDefault->set_left(1);
		$ftDefault->set_right(1);
		$ftDefault->set_size(10);
		// Field Type Date Time
		$ftDateTime = &$workbook->addformat(array(num_format => 'dd/mm/yyyy hh:mm'));
		$ftDateTime->set_align('center');
		$ftDateTime->set_align('vcenter');
		$ftDateTime->set_border_color('black');
		$ftDateTime->set_top(1);
		$ftDateTime->set_bottom(1);
		$ftDateTime->set_left(1);
		$ftDateTime->set_right(1);
		$ftDateTime->set_size(10);
		$worksheet = $workbook->addworksheet('CI');
		$worksheet->write(0, 0, 'ID', $ftHeader);
		$worksheet->write(0, 1, 'C(' . $idFormRecord . ',n) = ' . $strCIEquation, $ftHeader);
		$worksheet->write(0, 2, '[D]', $ftHeader);
		$worksheet->write(0, 3, '[T]', $ftHeader);
		$worksheet->write(0, 4, '[W]', $ftHeader);
		$worksheet->write(0, 5, '[P]', $ftHeader);
		$worksheet->write(0, 6, 'Distance (mts)', $ftHeader);
		$worksheet->write(0, 7, 'Diff Secs', $ftHeader);
		$worksheet->write(0, 8, 'Date/Time', $ftHeader);
		$arrCorrelations = $this->dblCorrelationIndex($idFormRecord, $strCIEquation, $dblClusterThreshold, $intDMAX, $intTMAX);
		foreach($arrCorrelations as $y => $arrCorrelation) {
			$worksheet->write($y+1, 0, $arrCorrelation['idFormRecord'], $ftDefault);
			$worksheet->write($y+1, 1, $arrCorrelation['dblCI'], $ftDefault);
			$worksheet->write($y+1, 2, $arrCorrelation['dblD'], $ftDefault);
			$worksheet->write($y+1, 3, $arrCorrelation['dblT'], $ftDefault);
			$worksheet->write($y+1, 4, $arrCorrelation['dblW'], $ftDefault);
			$worksheet->write($y+1, 5, $arrCorrelation['dblP'], $ftDefault);
			$worksheet->write($y+1, 6, number_format($arrCorrelation['dblDistanceMts'], 2), $ftDefault);
			$worksheet->write($y+1, 7, $arrCorrelation['intSeconds'], $ftDefault);
			$dblExcelDateTime = xl_date_list(
				date('Y', strtotime($arrCorrelation['dtLastUpdate'])),
				date('m', strtotime($arrCorrelation['dtLastUpdate'])),
				date('d', strtotime($arrCorrelation['dtLastUpdate'])),
				date('H', strtotime($arrCorrelation['dtLastUpdate'])),
				date('i', strtotime($arrCorrelation['dtLastUpdate']))
			);
			$worksheet->write($y+1, 8, $dblExcelDateTime, $ftDateTime);			
		}
		$worksheet->freeze_panes(1, 0); // Freeze
		$workbook->close();
		return $arrOutput;
	}
	
	public function dblCorrelationIndex($idFormRecord, $strCIEquation, $dblClusterThreshold, $intDMAX, $intTMAX, $idFormRecord2 = 0) {
		$arrFormRecord = $this->formrecord->selectFormRecords(0, 0, 0, $idFormRecord);
		$arrFormRecord = $arrFormRecord[0];
		$this->gPoint->setLongLat($arrFormRecord['dblLongitude'], $arrFormRecord['dblLatitude']);
		$arrCoordinates = array();
		$arrCoordinates[] = array('dblLat' => $arrFormRecord['dblLatitude'], 'dblLng' => $arrFormRecord['dblLongitude']);
		if ($idFormRecord2 > 0) {
			$arrFormRecords = $this->formrecord->selectFormRecords(0, 0, 0, $idFormRecord2);
		} else {
			$arrFormRecords = $this->formrecord->selectFormRecordsByPolygon('C', $arrFormRecord['idProject'], $arrCoordinates, '', $intDMAX);
		}
		$arrCluster = array();
		foreach($arrFormRecords as $item) {
			if ($item['idFormRecord'] == $idFormRecord) continue;
			// Distance
			$dblDistanceMts = $this->gPoint->distanceFrom($item['dblLongitude'], $item['dblLatitude']);
			$strDistance = $dblDistanceMts + ' mts';
			if ($strDistance > 100) {
				$strDistance = number_format($dblDistanceMts/100, 2) . ' kms';
			}
			$dblD = sprintf('%f', 1 - (min($dblDistanceMts, $intDMAX)/$intDMAX));
			// Time
			$intSeconds = abs(strtotime($item['dtLastUpdate']) - strtotime($arrFormRecord['dtLastUpdate']));
			$strTimeDifference = $intSeconds . ' secs';
			if ($intSeconds > 60) {
				$strTimeDifference = round($intSeconds/60) . ' min';
			}
			if ($intSeconds > 60*60) {
				$strTimeDifference = round($intSeconds/60/60) . ' hours';
			}
			if ($intSeconds > 60*60*24) {
				$strTimeDifference = round($intSeconds/60/60/24) . ' days';
			}
			$dblT = sprintf('%f', 1 - (min($intSeconds, $intTMAX) / $intTMAX));
			// Taxonomic
			$dblW = $this->dblTextSimilarity($arrFormRecord, $item);
			// Person
			$dblP = $item['idUser'] == $arrFormRecord['idUser'] ? 1 : 0;
			$strCI = strtr($strCIEquation, array(
				"[D]" => "$dblD", 
				"[T]" => "$dblT",
				"[DMAX]" => "$intDMAX", 
				"[TMAX]" => "$intTMAX",
				"[W]" => "$dblW",
				"[P]" => "$dblP"
			));
			$dblCI = $this->evalmath->evaluate($strCI);
			// If no greather than limit, do not cluster
			if ($dblCI < $dblClusterThreshold) { continue; }
			$arrCluster[] = array(
				'idFormRecord' => $item['idFormRecord'],
				'dblLatitude' => $item['dblLatitude'],
				'dblLongitude' => $item['dblLongitude'],
				'dtLastUpdate' => $item['dtLastUpdate'],
				'dblDistanceMts' => $dblDistanceMts,
				'strDistance' => $strDistance,
				'intSeconds' => $intSeconds,
				'strTimeDifference' => $strTimeDifference,
				'dblD' => number_format ($dblD, 2),
				'dblT' => number_format ($dblT, 2),
				'dblW' => number_format ($dblW, 2),
				'dblP' => number_format ($dblP, 2),
				'dblCI' => number_format ($dblCI, 2)
			);
		}
		return $arrCluster;
	}
	
	public function dblTextSimilarity($arrFR1, $arrFR2) {
		$dblW = $arrFR1['idForm'] == $arrFR2['idForm'] ? 1 : 0;;
		return $dblW;
	}
}
?>