<?php
class Database {
	public $strEventLogDefaultIcon		= 'icon-bell';
	public $strDefaultIcon				= 'icon-globe';
	public $blnSiteAllowProjectCreation	= 0;
	public $database;
	var $lastErr	= null;
	var $server 	= '';
	var $username 	= '';
	var $password 	= '';
	var $mydb		= '';
	var $admPassword;

	public function __construct($strPrefix = '') {
		include_once 'strings.php';
		$strings = new Strings();
		$this->strings = $strings;
		include $strPrefix . $this->strings->strConnectionFileName;
		$this->admPassword	= $admPassword;
		$this->server 		= $server;
		$this->username 	= $username;
		$this->password 	= $password;
		$this->mydb			= $database;
		$this->blnSiteAllowProjectCreation = $blnSiteAllowProjectCreation;
		$this->database 	= mysqli_connect($this->server, $this->username, $this->password, $this->mydb);
		$this->thread_id	= mysqli_thread_id($this->database);
		$this->setLastErr();
	}

	public function install() {
		new Database();
		if (! mysqli_ping($this->database)) return 0; // Could not connect to mysql host
		$link = mysqli_select_db($this->database, $this->mydb);
		if (! $link) {
			if (! $this->executeQuery('CREATE DATABASE IF NOT EXISTS ' . $this->mydb)) return 0;
			$link = mysqli_select_db($this->database, $this->mydb);
			if (! $link) { return 0; }
		}
		$link = new mysqli($this->server, $this->username, $this->password, $this->mydb);
		$query = file_get_contents($this->strings->strSQLDatabaseFile);
		if (mysqli_multi_query($link, $query)) {
			return 1;
		} else {
			return 0;
		}
	}

	public function blnTableExists() {
		new Database();
		$query = "SHOW COLUMNS FROM userprojectworkgroup";
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		return (count($result) > 0);
	}

	public function executeMultiQuery($query) {
		$result = mysqli_multi_query($this->database, $query);
		while(mysqli_next_result($this->database)){;}
		return $result;
	}
	
	public function executeQuery($query, $blnAllowAbort = false) {
		if ($blnAllowAbort) {
			//$this->abortQuery();
		}
		mysqli_select_db($this->database, $this->mydb);
		$result = mysqli_query($this->database, $query);
		$this->thread_id = mysqli_thread_id($this->database);
		$this->setLastErr();
		return $result;
	}
	
	public function abortQuery() {
		// show processlist; KILL 2894;
		if ($this->thread_id) {
			$blnResult = mysqli_kill($this->database, $this->thread_id);
			$this->database = mysqli_connect($this->server, $this->username, $this->password, $this->mydb);
			//$fh = fopen("tmp/out.txt", 'a');fwrite($fh, "[" . date('H:i:s', time()) . "] " .  $this->thread_id .'>'. $blnResult . chr(13));fclose($fh);
		}
		return $blnResult;
	}

	public function getDatabaseSize() {
		$query =
		"SELECT table_schema \"test\", SUM( data_length + index_length) / 1024 / 1024
			\"Data Base Size in MB\" FROM information_schema.TABLES GROUP BY table_schema";
	}

	public function isConnected() {
		return mysqli_select_db($this->database, $this->mydb);
		//return mysqli_ping($this->database);
	}

	public function getLastErr() {
		return $this->lastErr;
	}

	private function setLastErr() {
		$this->lastErr = mysqli_error($this->database);
	}

	public function getLastInsertedID() {
		return mysqli_insert_id($this->database);
	}

	public function getNumAffectedRows() {
		return mysqli_affected_rows($this->database);
	}

	public function close() {
		mysqli_close($this->database);
		$this->database = null;
	}

	/**
	 * Esta funo limpa o resultado retornado pelo mysql_query para ficar num formato mais amigvel.
	 * @param mysql_result $resultado
	 */
	public function prepareReturn($resultado) {
		if($this->getLastErr() == null) {
			$retorno = Array();
			while(($linha = mysqli_fetch_array($resultado)) != null) {
				$aux = Array();
				foreach($linha as $chave2 => $valor2) {
					if(!is_numeric($chave2)) {
						$aux[$chave2] = $valor2;
					}
				}
				$retorno[] = $aux;
			}
			return $retorno;
		} else {
			return null;
		}
	}

	public function log($string) {
		$fp = fopen('log.txt', 'a');
		fwrite($fp, $string);
		fclose($fp);
	}
	
	public function selectCountry($blnJustFlags = false) {
		$strFlagFolder = 'img/language/';
		$query =
		"SELECT
			c.idCountry,
			c.strName,
			c.strCapital,
			c.strTelAreaCode,
			c.strCurrencySymbol,
			c.strLanguageCode
		FROM
			country c
		ORDER BY
			c.strName";
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		if ($blnJustFlags) {		
			for ($idLine=count($result)-1; $idLine >= 0; $idLine--) {
				$strFlagPath = $strFlagFolder . $result[$idLine]['strLanguageCode'] . '.png';
				if (file_exists($strFlagPath)) {
					$result[$idLine]['strFlagPath'] = $strFlagPath;
				} else {
					array_splice($result,$idLine,1);
				}
			}
		}
		return $result;

	}
	
	public function selectDatum($idDatum = 0) {
		$query =
		"SELECT
			idDatum,
			strName,
			dblA,
			dblE2
		FROM
			datum d
		" . ($idDatum > 0 ? " WHERE idDatum = " . $idDatum : "") . "
		ORDER BY
			strName";
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		return $result;
	}
	
	public function intSelectNextTableKey($strTable, $strPrimaryKeyField) {
		$query = "SELECT MAX(`" . $strPrimaryKeyField . "`) AS `intMAX` FROM " . $strTable;
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		$result[0]['intMAX'];
		return ($result[0]['intMAX'] ? $result[0]['intMAX'] : 0) + 1;
	}
	
	// User Event
	public function selectEvents($idProject = 0, $idUser = 0, $idEventType = 0, $dtDateFrom = '', $dtDateTo = '', $intLimit = 99999, $blnFromMobile = false, $strIDProjects = '', $strIDEventTypes = '', $blnIndex = 0) {
		$query =
		"SELECT
			e.idEvent,
			e.idEventType,
			e.idUser,
			e.dtDateTime,
			e.strParam1,
			e.strParam2,
			e.strParam3,
			p.idProject,
			p.strName AS `strProjectName`,
			p.strAlias,
			u.strEmail,
			u.strName AS `strUsername`
		FROM
			event	e,
			user	u,
			project p
		WHERE
			e.idUser = u.idUser AND
			p.idProject = u.idProject			
		" . ($idProject > 0 ? " AND u.idProject = " . $idProject : "") . "
		" . ($idUser > 0 ? " AND e.idUser = " . $idUser : "") . "
		" . ($idEventType > 0 ? " AND e.idEventType = " . $idEventType : "") . "
		" . ($dtDateFrom  ? " AND e.dtDateTime >= '" . $dtDateFrom . ($blnFromMobile ? "" : " 00:00:00") . "'" : "") . "
		" . ($dtDateTo ? " AND e.dtDateTime <= '" . $dtDateTo . ($blnFromMobile ? "" : " 23:59:59") . "'" : "") . "
		" . ($strIDProjects ? " AND p.idProject IN (" . $strIDProjects . ")" : "") . "
		" . ($strIDEventTypes ? " AND e.idEventType IN (" . $strIDEventTypes . ")" : "") . "
		" . ($blnIndex  ? " AND e.idEventType <> 7 AND e.idEventType <> 8 AND e.idEventType <> 9 AND e.idEventType <> 19 AND e.idEventType <> 28" : "") . "
		ORDER BY
			e.dtDateTime DESC 
		" . ($intLimit ? " LIMIT " . $intLimit : "")
		;
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		foreach ($result as $idLine => $item) {
			$result[$idLine]['strDateTime'] = date('d/m/y H:i:s', strtotime($item['dtDateTime']));
			$result[$idLine]['strDateTimeShort'] = date('d/m H:i', strtotime($item['dtDateTime']));
			$result[$idLine]['strEventType'] = $_SESSION['strEventType_' . $item['idEventType']];
			$result[$idLine]['strEmailAbbreviated'] = strpos($result[$idLine]['strEmail'], '@') ? substr($result[$idLine]['strEmail'], 0, strpos($result[$idLine]['strEmail'], '@')) : $result[$idLine]['strEmail'];
			$result[$idLine]['strEventTypeColor'] = '#0000ff';
			if ($item['idEventType'] == 2 || $item['idEventType'] == 4 || $item['idEventType'] == 9 || $item['idEventType'] == 11 || $item['idEventType'] == 15 || $item['idEventType'] == 22 || $item['idEventType'] == 25) { 
				$result[$idLine]['strEventTypeColor'] = '#ff0000';
			} else if ($item['idEventType'] == 1 || $item['idEventType'] == 3 || $item['idEventType'] == 10 || $item['idEventType'] == 13 || $item['idEventType'] == 23) { 
				$result[$idLine]['strEventTypeColor'] = '#139846';
			}
		}
		return $result;
	}
	
	public function insertEvent($idEventType, $idUser = 0, $strParam1 = '', $strParam2 = '', $strParam3 = '', $strDate = '') {
		$query = "
			INSERT INTO event SET 
				idEventType	=	" . $idEventType . ",
				idUser		=	" . $idUser . ",
				dtDateTime	=	" . ($strDate ? "'" . $strDate . "'" : "NOW()") . 
				($strParam1 ? ", strParam1 =	'" . $strParam1 . "'" : "") .
				($strParam2 ? ", strParam2 =	'" . $strParam2 . "'" : "") .
				($strParam3 ? ", strParam3 =	'" . $strParam3 . "'" : "")
		;
		$result = $this->executeQuery($query);
		return true;
	}
	
	public function deleteEvent($idProject = 0, $idUser = 0, $idEventType = 0) {
		if ($idProject > 0) {
			$query = "DELETE eventuser FROM eventuser, user WHERE eventuser.idUser = user.idUser AND user.idProject = " . $idProject;
		} else {
			$query = "DELETE FROM eventuser WHERE " . ($idUser > 0 ? "idUser = " . $idUser : "") . ($idEventType > 0 ? "idEventType = " . $idEventType : "");
		}
		$resultado = $this->executeQuery($query);
		return true;
	}
	
	public function selectEventTypes($idEventType = 0) {	
		$query =
		"SELECT
			et.idEventType,
			et.strEventType
		FROM
			eventtype	et
		" . (($idEventType > 0) ? " WHERE et.idEventType = " . $idEventType : "") . "
		ORDER BY
			et.idEventType";
		$result = $this->executeQuery($query);
		$result = $this->prepareReturn($result);
		foreach ($result as $idLine => $item) {
			$result[$idLine]['strEventType'] = $_SESSION['strEventType_' . $item['idEventType']];
		}
		return $result;
	}
	
	public function downloadEvents($idProject, $idUser, $dtDateFrom, $dtDateTo) {
		$arrResult['strFilePath'] = 'events.xls';
		$arrResult['strFilePathTMP'] = $this->strings->strSiteTmpFileFolder . '/' . $this->strings->generateRandomString(5) . '.xls';
		require_once "js/excelwriter/class.writeexcel_workbookbig.inc.php";
		require_once "js/excelwriter/class.writeexcel_worksheet.inc.php";
		require_once "js/excelwriter/functions.writeexcel_utility.inc.php";
		$workbook = new writeexcel_workbookbig($arrResult['strFilePathTMP']);
		// Header Format
		$ftHeader = &$workbook->addformat();
		$ftHeader->set_bold();
		$ftHeader->set_align('center');
		$ftHeader->set_align('vcenter');
		$ftHeader->set_color(0x09); // White
		$ftHeader->set_bg_color(0x17); // Gray
		$ftHeader->set_size(10);
		// Field Type Date Time
		$ftDateTime = &$workbook->addformat(array(num_format => 'dd/mm/yyyy hh:mm'));
		$ftDateTime->set_border_color(0x08); // Black
		$ftDateTime->set_top(1);
		$ftDateTime->set_bottom(1);
		$ftDateTime->set_left(1);
		$ftDateTime->set_right(1);
		// Cell Format - Error when printing to big amounts of data
		$ftCell = &$workbook->addformat();
		$ftCell->set_border_color(0x08); // Black
		$ftCell->set_top(1);
		$ftCell->set_bottom(1);
		$ftCell->set_left(1);
		$ftCell->set_right(1);
		$worksheet = $workbook->addworksheet('events');
		// Header
		$worksheet->write(0, 0, $_SESSION['strGlobalDate'], $ftHeader);
		$worksheet->set_column(0, 0, 15); 
		$worksheet->write(0, 1, $_SESSION['stradmManageEventsEventType'], $ftHeader);
		$worksheet->set_column(1, 1, 30); 
		$worksheet->write(0, 2, $_SESSION['stradmManageEventsUser'], $ftHeader);
		$worksheet->set_column(2, 2, 30); 
		if ($idProject == 0) {
		$worksheet->write(0, 3, $_SESSION['stradmManageProjectPreferencesName'], $ftHeader);
		$worksheet->set_column(3, 3, 30); 
		}
		$arrEvents = $this->selectEvents($idProject, $idUser, $idEventType, $dtDateFrom, $dtDateTo);
		foreach ($arrEvents as $intRow => $arrEvent) {
			$dblExcelDateTime = xl_date_list(
				date('Y', strtotime($arrEvent['dtDateTime'])),
				date('m', strtotime($arrEvent['dtDateTime'])),
				date('d', strtotime($arrEvent['dtDateTime'])),
				date('H', strtotime($arrEvent['dtDateTime'])),
				date('i', strtotime($arrEvent['dtDateTime']))
			);
			$worksheet->write($intRow+1, 0, $dblExcelDateTime, $ftDateTime);
			$worksheet->write($intRow+1, 1, $arrEvent['strEventType'], $ftCell);
			$worksheet->write($intRow+1, 2, $arrEvent['strName'] ? $arrEvent['strName'] : $arrEvent['strEmail'], $ftCell);
			if ($idProject == 0) {
				$worksheet->write($intRow+1, 3, $arrEvent['strProjectName'], $ftCell);
			}
		}
		// Set Col Width 
		$worksheet->freeze_panes(1, 0); // Freeze Row 1
		$workbook->close();
		return $arrResult;
	}
}
?>