<?php
class rs2 {
	public function __construct() {
		include_once 'gPoint.php';
		$gPoint = new gPoint();
		$this->gPoint = $gPoint;
	}
	
	public function create($strOutputFile, $strTitle = '', $strAuthor = '', $intResolution, $intLatSW, $intLngSW, $intZoneSW, $intHemisphere, $intHeight, $intWidth, $arrClasses, $pngCanvas) {
	  $fh = fopen($strOutputFile, 'wb');
	  // Writing File Header
	  fwrite($fh, pack('I',16), 1);				// File Format - rst2006 = 16
	  $this->WriteString($fh, $strTitle);		// Title
	  $this->WriteString($fh, $strAuthor);		// Author
	  $this->WriteByte($fh, date('d'));			// Day
	  $this->WriteByte($fh, date('m'));			// Month
	  $this->WriteByte($fh, date('y'));			// Year
	  $this->WriteWord($fh, $intResolution);	// Resolution
	  $this->WriteWord($fh, $intZoneSW);		// Zone
	  $this->WriteByte($fh, $intHemisphere);	// Hemisphere 1 = S, 0 = N			
	  $intLatNE = $intLatSW + $intResolution*$intHeight;
	  $intLngNE = $intLngSW + $intResolution*$intWidth;
	  $this->WriteInt($fh, $intLatSW);			// LatSW
	  $this->WriteInt($fh, $intLngSW);			// LngSW
	  $this->WriteInt($fh, $intLatNE);			// LatNE
	  $this->WriteInt($fh, $intLngNE);			// LngNE
	  $this->WriteWord($fh, $intHeight);		// Map Height
	  $this->WriteWord($fh, $intWidth);			// Map Width
	  $intNClasses = count($arrClasses);		// Number of Classes
	  $this->WriteWord($fh, $intNClasses+1);
	  // Write Classes
	  // Writing First Background Class
	  $this->WriteWord($fh, 0);
	  $this->WriteString($fh, 'FUNDO');
	  for ($i=0;$i<$intNClasses;$i++) {
		  $this->WriteWord($fh, $i+1);
		  $this->WriteString($fh, $arrClasses[$i]['strClass']);
	  }
	  // Writing  Map Canvas
	  for ($y=0;$y<$intHeight;$y++) {
		  // Writing line number
		  $this->WriteInt($fh, $y+1);
		  $intCol = 0;
		  do {
			  $intRep = 0;
			  $imgColor = imagecolorat($pngCanvas, $intCol, $y);
			  do {
				  $intRep++;
				  $intCol++;
			  } while (($intCol < $intWidth) && ($imgColor == imagecolorat($pngCanvas, $intCol, $y)));
			  $this->WriteWord($fh, $intRep);
			  $this->WriteWord($fh, $imgColor);
		  } while ($intCol < $intWidth);
		  $this->WriteByte($fh, 0); // Mark End of Line
	  }
	  // Writing Set of Colors at End of File
	  $this->WriteInt($fh, hexdec('FFFFFF')); // White = BACKGROUND
	  for ($i = 0; $i < $intNClasses; $i++) {
		  $this->WriteInt($fh, $arrClasses[$i]['intColor']);
	  }
	  fclose($fh);
	}
	
	public function WriteString($f, $str) {
		for ($i=0; $i < strlen($str);$i++) {
			$s = $str[$i];
			fwrite($f, $s, 1);
		}
		fwrite($f, chr(0)); // Mark End of Line
	}
	
	public function WriteByte($f, $byte) {
		$byte = pack('I', $byte);
		fwrite($f, $byte, 1); // 1 Byte
	}
	
	public function WriteWord($f, $word) {
		$word = pack('S', $word);
		fwrite($f, $word, 2); // 2 Bytes
	}
	
	public function WriteInt($f, $int) {
		$int = pack('L', $int);
		fwrite($f, $int, 4); // 4 Bytes
	}
	
	public function WriteDouble($f, $double) {
		$double = pack('d', $double); 
		fwrite($f, $double, 8); // 8 Bytes
	}

	public function convertLatLngToXY($dblLat, $dblLng, $intResolution, $arrBBox, $gPoint = NULL) {
		$gPoint = $gPoint ? $gPoint : $this->gPoint;
		$gPoint->setLongLat($dblLng, $dblLat);
		$X = $gPoint->distanceFrom($arrBBox['dblLngSW'], $dblLat) / $intResolution;
		if ($dblLng < $arrBBox['dblLngSW']) $X = -$X;
		$Y = $gPoint->distanceFrom($dblLng, $arrBBox['dblLatNE']) / $intResolution;
		if ($dblLat > $arrBBox['dblLatNE']) $Y = -$Y;
		return array('X'=>$X, 'Y'=>$Y);
	}
}
?>