<?php
class Stats {
	public $strDefaultIcon	= 'fa fa-bar-chart';

	public function __construct($database) {
		$this->database = $database;

		include_once 'strings.php';
		$strings = new Strings();
		$this->strings = $strings;
		
		session_start();
	}
	
	public function selectProjectSearch($idProject = 0, $intDays=9999, $intCountMin = 1) {
		$query =
		"SELECT
			strSearch, COUNT(strSearch) as `intCount` 
		FROM
			projectsearch ps
		WHERE
			ps.idProject = " . $idProject  . " AND 
			ps.dtDateSearch >= CURDATE() - INTERVAL " . $intDays . " DAY
		GROUP BY
			ps.strSearch
		HAVING
			intCount >= " . $intCountMin  . "
		ORDER BY
			intCount DESC 
		LIMIT 30
		";
		$result = $this->database->executeQuery($query);
		$result = $this->database->prepareReturn($result);
		foreach ($result as $idLine => $item) {
			$result[$idLine]['strSearch'] = strip_tags($result[$idLine]['strSearch']);
		}
		return $result;
	}
	
	public function insertProjectSearch($idProject, $strStrings) {
		if (! $strStrings) return;
		$arrStrings = explode(';', $strStrings);
		$strInsert = '';
		foreach ($arrStrings as $strString) {
			if (! $strString) continue;
			$strStrings = strip_tags($strStrings);
			$strInsert .= ($strInsert ? "," : "") . " (" . $idProject . ", NOW(),'" . $strString . "')";
		}
		if (! $strInsert) return false;
		$query = "REPLACE INTO projectsearch (idProject, dtDateSearch, strSearch) VALUES " . $strInsert;
		$result = $this->database->executeQuery($query);
		return $this->database->getLastInsertedID();
	}
	
	public function deleteProjectSearch($idProject) {
		$query = "DELETE FROM projectsearch WHERE idProject=" . $idProject;
		$result = $this->database->executeQuery($query);
		return $this->database->getNumAffectedRows();
	}
	
	public function chartLoadData($idChart, $idProject, $idUser, $dtDateFrom, $dtDateTo) {
		$arrResult = array();
		// Calc number of days in range to define step
		$diff = abs(strtotime($dtDateTo) - strtotime($dtDateFrom));
		$intDays = floor($diff/(60*60*24));
		$strInterval = ($intDays <= 31 ? 'DAY' : 'MONTH');
		if ($idChart == 1) { // Access X Day
			$query = "
				SELECT 
					CONCAT(DAY(e.dtDateTime),'/',MONTH(e.dtDateTime)) as `X`,
					COUNT(e.idEvent) as `Y1` 
				FROM
					event e,
					user u
				WHERE 
					e.idEventType = 19 AND 
					e.idUser = u.idUser 
					" . ($idProject > 0 ? " AND u.idProject = " . $idProject : "") . "
					" . ($idUser > 0 ? " AND u.idUser = " . $idUser : "") . "
					" . ($dtDateFrom  ? " AND e.dtDateTime >= '" . $dtDateFrom . "  00:00:00'" : "") . "
					" . ($dtDateTo ? " AND e.dtDateTime <= '" . $dtDateTo . "  23:59:59'" : "") . "
				GROUP BY 
					" . $strInterval . "(e.dtDateTime) 
				ORDER BY 
					e.dtDateTime
			";
			$result = $this->database->executeQuery($query);
			$result = $this->database->prepareReturn($result);
			// Labels
			$arrResult['strType'] = 'line';
			$arrResult['strTitle'] = $_SESSION['stradmStatsTitleVisits'] . ' x ' . $_SESSION['stradmStatsTitleDay'];
			$arrResult['arrLabels'][0] = $_SESSION['stradmStatsTitleVisits'];
			$arrResult['arrLabels'][1] = $_SESSION['stradmStatsTitleDay'];
			foreach ($result as $idLine => $item) {
				$arrResult['arrValues'][$idLine][] = $result[$idLine]['X'];
				$arrResult['arrValues'][$idLine][] = $result[$idLine]['Y1'];
			}
		} else if ($idChart == 2) { // Top 10 Access Record
			$query = "
				SELECT 
					e.strParam1 as `X`,
					COUNT(e.strParam1) as `Y1` 
				FROM
					event e,
					user u
				WHERE 
					e.idEventType = 28 AND
					e.idUser = u.idUser 
					" . ($idProject > 0 ? " AND u.idProject = " . $idProject : "") . "
					" . ($idUser > 0 ? "  AND u.idUser = " . $idUser : "") . "
					" . ($dtDateFrom  ? " AND e.dtDateTime >= '" . $dtDateFrom . "  00:00:00'" : "") . "
					" . ($dtDateTo ? " AND e.dtDateTime <= '" . $dtDateTo . "  23:59:59'" : "") . "
				GROUP BY
					e.strParam1
				ORDER BY 
					`Y1` DESC
				LIMIT 10
			";
			$result = $this->database->executeQuery($query);
			$result = $this->database->prepareReturn($result);
			// Labels
			$arrResult['strType'] = 'bar';
			$arrResult['strTitle'] = 'ID x ' . $_SESSION['stradmStatsTitleViews'];
			$arrResult['arrLabels'][0] = 'ID';
			$arrResult['arrLabels'][1] = $_SESSION['stradmStatsTitleViews'];
			foreach ($result as $idLine => $item) {
				$arrResult['arrValues'][$idLine][] = $result[$idLine]['X'];
				$arrResult['arrValues'][$idLine][] = $result[$idLine]['Y1'];
			}
		} else if ($idChart == 3) { // Top 5 Users X Access (Login) X Month
			$query = "
				SELECT 
					u.strEmail as `X`,
					COUNT(e.idUser) as `Y1`
				FROM
					event	e,
					user	u
				WHERE 
					e.idEventType = 1 AND
					e.idUser = u.idUser 
					" . ($idProject > 0 ? " AND u.idProject = " . $idProject : "") . "
					" . ($idUser > 0 ? " AND u.idUser = " . $idUser : "") . "
					" . ($dtDateFrom  ? " AND e.dtDateTime >= '" . $dtDateFrom . "  00:00:00'" : "") . "
					" . ($dtDateTo ? " AND e.dtDateTime <= '" . $dtDateTo . "  23:59:59'" : "") . "
				GROUP BY
					`X`
				ORDER BY 
					`Y1` DESC
				LIMIT 5
			";
			$result = $this->database->executeQuery($query);
			$result = $this->database->prepareReturn($result);
			// Labels
			$arrResult['strType'] = 'bar';
			$arrResult['strTitle'] = $_SESSION['stradmStatsTitleUsers'] . ' x ' . $_SESSION['stradmStatsTitleAccess'];
			$arrResult['arrLabels'][0] = $_SESSION['stradmStatsTitleUsers'];
			$arrResult['arrLabels'][1] = $_SESSION['stradmStatsTitleAccess'];
			foreach ($result as $idLine => $item) {
				$arrResult['arrValues'][$idLine][] = $result[$idLine]['X'];
				$arrResult['arrValues'][$idLine][] = $result[$idLine]['Y1'];
			}
		} else if ($idChart == 4) { // # Records x Form
			$query = "
				SELECT 
					f.strName as `X`,
					COUNT(fr.idFormRecord) as `Y1`
				FROM
					form		f,
					formrecord	fr
				WHERE 
					f.idForm = fr.idForm 
					" . ($idProject > 0 ? " AND f.idProject = " . $idProject : "") . "
					" . ($idUser > 0 ? " AND fr.idUser = " . $idUser : "") . "
					" . ($dtDateFrom  ? " AND fr.dtLastUpdate >= '" . $dtDateFrom . "  00:00:00'" : "") . "
					" . ($dtDateTo ? " AND fr.dtLastUpdate <= '" . $dtDateTo . "  23:59:59'" : "") . "
				GROUP BY
					`X`
				ORDER BY 
					`Y1` DESC
			";
			$result = $this->database->executeQuery($query);
			$result = $this->database->prepareReturn($result);
			// Labels
			$arrResult['strType'] = 'bar';
			$arrResult['strTitle'] = $_SESSION['stradmStatsTitleCreatedRecords'] . ' x ' . $_SESSION['stradmStatsTitleForms'];
			$arrResult['arrLabels'][0] = $_SESSION['stradmStatsTitleCreatedRecords'];
			$arrResult['arrLabels'][1] = $_SESSION['stradmStatsTitleForms'];
			foreach ($result as $idLine => $item) {
				$arrResult['arrValues'][$idLine][] = $result[$idLine]['X'];
				$arrResult['arrValues'][$idLine][] = $result[$idLine]['Y1'];
			}
		} else if ($idChart == 5) { // Top Users X Records Creation
			$query = "
				SELECT 
					u.strEmail as `X`,
					COUNT(fr.idUser) as `Y1`
				FROM
					user	u,
					formrecord fr
				WHERE 
					u.idUser = fr.idUser
					" . ($idProject > 0 ? " AND u.idProject = " . $idProject : "") . "
					" . ($idUser > 0 ? " AND u.idUser = " . $idUser : "") . "
					" . ($dtDateFrom  ? " AND fr.dtLastUpdate >= '" . $dtDateFrom . "  00:00:00'" : "") . "
					" . ($dtDateTo ? " AND fr.dtLastUpdate <= '" . $dtDateTo . "  23:59:59'" : "") . "
				GROUP BY
					u.idUser
				ORDER BY 
					`Y1` DESC
				LIMIT 30
			";
			$result = $this->database->executeQuery($query);
			$result = $this->database->prepareReturn($result);
			// Labels
			$arrResult['strType'] = 'bar';
			$arrResult['strTitle'] = $_SESSION['stradmStatsTitleUsers'] . ' x ' . $_SESSION['stradmStatsTitleCreatedRecords'];
			$arrResult['arrLabels'][0] = $_SESSION['stradmStatsTitleUsers'];
			$arrResult['arrLabels'][1] = $_SESSION['stradmStatsTitleCreatedRecords'];
			foreach ($result as $idLine => $item) {
				$arrResult['arrValues'][$idLine][] = $result[$idLine]['X'];
				$arrResult['arrValues'][$idLine][] = $result[$idLine]['Y1'];
			}
		}
		return $arrResult;
	}
	
	public function downloadStats($idProject, $idUser, $dtDateFrom, $dtDateTo) {
		$arrResult['strFilePath'] = 'stats.xlsx';
		$arrResult['strFilePathTMP'] = $this->strings->strSiteTmpFileFolder . '/' . $this->strings->generateRandomString(5) . '.xlsx';
		require_once ('js/excel/Classes/PHPExcel.php');
		$workbook = new PHPExcel();	
		$objWorksheet = $workbook->getActiveSheet();
		$workbook->setActiveSheetIndex(0);	
		$query = "
			SELECT 
				u.strEmail,
				u.strName,
				" . ($idProject == 0 ? "p.strName AS `strProjectName`," : "") . "
				COUNT(fr.idUser) as `Y1`
			FROM
				project		p,
				user		u
			LEFT JOIN 
				formrecord	fr
			ON 
				u.idUserLevel >= 3 AND 
				u.idUser = fr.idUser
				" . ($idUser > 0 ? " AND u.idUser = " . $idUser : "") . "
				" . ($dtDateFrom  ? " AND fr.dtLastUpdate >= '" . $dtDateFrom . " 00:00:00'" : "") . "
				" . ($dtDateTo ? " AND fr.dtLastUpdate <= '" . $dtDateTo . "  23:59:59'" : "") . "
			WHERE
				u.idProject = p.idProject
				" . ($idProject > 0 ? " AND u.idProject = " . $idProject : "") . "
			GROUP BY
				u.idUser
			ORDER BY 
				" . ($idProject == 0 ? "`strProjectName`," : "") . "
				u.strName
		";
		$result = $this->database->executeQuery($query);
		$result = $this->database->prepareReturn($result);
		// Header
		$workbook->getActiveSheet()->setCellValueByColumnAndRow(0, 1, $this->strings->changeCharAccent($_SESSION['strIndexMenuUser'] . ' (' . $_SESSION['stradmStatsDownloadUserStatsExcelTip'] . ')'));
		$workbook->getActiveSheet()->setCellValueByColumnAndRow(1, 1, $this->strings->changeCharAccent($_SESSION['strGlobalRecords']) . ' ' . date('d/m/y', strtotime($dtDateFrom)) . ' - ' . date('d/m/y', strtotime($dtDateTo)));
		if ($idProject == 0) {
		$workbook->getActiveSheet()->setCellValueByColumnAndRow(2, 1, $this->strings->changeCharAccent($_SESSION['stradmManageProjectPreferencesName']));
		}
		foreach ($result as $intRow => $item) {
			$workbook->getActiveSheet()->setCellValueByColumnAndRow(0, $intRow+2, $this->strings->changeCharAccent($item['strName'] ? $item['strName'] : $item['strEmail']));
			$workbook->getActiveSheet()->setCellValueByColumnAndRow(1, $intRow+2, $item['Y1']);
			if ($idProject == 0) {
			$workbook->getActiveSheet()->setCellValueByColumnAndRow(2, $intRow+2, $this->strings->changeCharAccent($item['strProjectName']));
			}
		}
		$workbook->setActiveSheetIndex(0);
		$objworkbook = PHPExcel_IOFactory::createWriter($workbook, 'Excel2007');
		$objworkbook->save($arrResult['strFilePathTMP']);
		return $arrResult;
	}
}
?>