<? 
  include_once 'engine/database.php';
  $database = new Database();
  include_once 'engine/strings.php';
  $strings = new Strings();
  include_once 'engine/project.php';
  $project = new Project($database);
  include_once 'engine/datasource.php';
  $datasource = new Datasource($database);
  
  session_start();
  set_time_limit(10000);

  $strServiceLogFile = 'service.txt';
  // DEFINING ACTION BASED ON action PARAMETER (BACKUP BY DEFAULT)
  $chrAction = 'BACKUP';
  if (strpos($_GET['action'], 'GATHER') !== FALSE) $chrAction = 'GATHER';

  $strings->log('START SERVICE [' . $chrAction . ']', $strServiceLogFile, true);
  switch ($chrAction) {
	case 'BACKUP': 	// Check for Backup Schedule
	  $arrProjects = $project->selectProjects(0, '', 1); // Just Actives
	  foreach ($arrProjects as $arrProject) {
		$strings->log(' BACKUP PROJECT [' . $arrProject['strName'] . '] OWNER [' . $arrProject['strUserCreator'] . ']', $strServiceLogFile, true);
		// If no valid email, skip backup
		if (strpos($arrProject['strUserCreator'], '@') === FALSE) { continue; }
		// Load Strings
		$strings->loadLanguage($arrProject['strLanguageCode']);
		if (! $arrProject['dtBackupLastExecution']) {
		  $project->backupBackup($arrProject['idProject']);
		  $strings->log(' BACKUP SUCCESS!', $strServiceLogFile, true);
		} else {
		  $intDiffSecs = abs(time() - strtotime($arrProject['dtBackupLastExecution']));
		  $intDaysSinceLastBackup = floor($intDiffSecs/(60*60*24));
		  if ($intDaysSinceLastBackup >= $arrProject['intBackupFrequencyDays']) {
			$project->backupBackup($arrProject['idProject']);
			$strings->log(' BACKUP SUCCESS!', $strServiceLogFile, true);
		  } else {
			$strings->log(' BACKUP NOT NEEDED: LAST PERFORMED ' . $intDaysSinceLastBackup . ' DAY(S) AGO. PROJECT BACKUP FREQUENCY ' . $arrProject['intBackupFrequencyDays'] . ' DAYS', $strServiceLogFile, true);
		  }
		}
	  }
	break;
	case 'GATHER': // Check for Datasource Gahter Schedule
	  $strings->log('START SERVICE [' . $chrAction . ']', $strServiceLogFile, true);
	  $arrDataSourceUserSearchs = $datasource->selectDataSourceUserSearchs(0, 0, true);
	  foreach ($arrDataSourceUserSearchs as $arrDataSourceUserSearch){
		// When intUpdateFrequencyMin = 0 => Programed Gather is Disabled
		if (! $arrDataSourceUserSearch['intUpdateFrequencyMin'] > 0) { continue; }
		$strings->log(' DATA SOURCE [' . $arrDataSourceUserSearch['strName'] . ' (' . $arrDataSourceUserSearch['idDataSource'] . ')] | KEYWORD [' . $arrDataSourceUserSearch['strKeyword'] . '] | PROJECT [' . $arrDataSourceUserSearch['idProject'] . '] | USER [' . $arrDataSourceUserSearch['strEmail'] . ' (' . $arrDataSourceUserSearch['idUser'] . ')]', $strServiceLogFile, true);
		// Check if last time user logged in (event->idEvent = 1) was more than $datasource->intMaxDaysServiceOn, disable service and notify via email
		$strDateFromBR = date('d/m/Y', strtotime('-' . $datasource->intMaxDaysServiceOn . ' days'));
		$arrUserEventLogins = $database->selectEvents($arrDataSourceUserSearch['idProject'], $arrDataSourceUserSearch['idUser'], 1, $strDateFromBR, '', 1);
		if (! count($arrUserEventLogins)) { 
			// Remove from User Search Table
			$datasource->updateDataSourceUserSearch($arrDataSourceUserSearch['idDataSource'], $arrDataSourceUserSearch['idUser'], '', true);
			// Register into log file
			$strMessage = '  - GATHER REMOVED FROM SCHEDULE DUE TO ACCOUNT INACTIVITY! MORE THAN ' . $datasource->intMaxDaysServiceOn . ' DAYS SINCE LAST LOGIN';
			$strings->log($strMessage, $strServiceLogFile, true);
			// Send notification e-mail (if exists)
			if (strpos($arrDataSourceUserSearch['strEmail'], '@') !== FALSE) { 
			  $arrSessions = array();
			  $arrSessions[0]['strTitle'] = 'GATHER SERVICE DISABLED';
			  $arrSessions[0]['strContent'] = '
				KEYWORD: ' . $arrDataSourceUserSearch['strKeyword'] . '<BR>
				PROJECT: ' . $arrDataSourceUserSearch['idProject'] . '<BR>
				USER: ' . $arrDataSourceUserSearch['strEmail'] . ' (' . $arrDataSourceUserSearch['idUser'] . ')<BR>
			  	DATA SOURCE: ' . $arrDataSourceUserSearch['strName'] . ' (' . $arrDataSourceUserSearch['idDataSource'] . ')<BR>
				REASON: ' . $strMessage . '<BR>
				<b>TO REACTIVATE IT, LOGIN INTO YOUR VICON SAGA PROJECT AND CHECK DATA SOURCES AGAIN</b>
			  ';
			  $strBody = $this->strings->mailFormatContent(2, $_SESSION['strReportTitle'], '<span style="font-weight:bold;color:#FF0000">' . $_SESSION['strReportWarning'] . '</span>', '', $arrSessions);
			  $strSubject = $this->strings->strUpperAccents($this->strings->strSiteName . ': GATHER SERVICE DISABLED');
			  $this->strings->sendMail($strSubject, $strBody, $this->strings->strSiteEmail, $arrDataSourceUserSearch['strEmail']);
			}
			continue;
		}
		// Checking if exceeded gather frequency
		$intDiffSecs = abs(time() - strtotime($arrDataSourceUserSearch['dtSearch']));
		$intMinsSinceLastGather = floor($intDiffSecs/60);
		if ($intMinsSinceLastGather >= $arrDataSourceUserSearch['intUpdateFrequencyMin']) {
		  // Call gather procedure
		  $arrResults = $datasource->search($arrDataSourceUserSearch['idProject'], $arrDataSourceUserSearch['idUser'], $arrDataSourceUserSearch['idDataSource'], $arrDataSourceUserSearch['strKeyword']);
		  // Register into log file
		  $strings->log('  + GATHER SUCCESS! ' . count($arrResults)  . ' RECORDS INSERTED', $strServiceLogFile, true);
		  $database->insertEvent(30, $arrDataSourceUserSearch['idUser'], 'RECORDS INSERTED [' . count($arrResults)  . '] | SEARCH KEYWORD [' . $arrDataSourceUserSearch['strKeyword'] . '] | DATA SOURCE [' . $arrDataSourceUserSearch['strName'] . '] | USER [' . $arrDataSourceUserSearch['strEmail'] . ' (' . $arrDataSourceUserSearch['idUser'] . ')] | PROJECT [' . $arrDataSourceUserSearch['idProject'] . ']');
		} else {
		  // Register into log file
		  $strings->log('  - GATHER NOT NEEDED: ' . $intMinsSinceLastGather . '/' . $arrDataSourceUserSearch['intUpdateFrequencyMin'] . ' MINUTES FROM LAST GATHER', $strServiceLogFile, true);
		}
	  }
	break;
  }
?>